<Cabbage>
#define PLANT colour(76,130,180,155) outlineColour(0,0,0,255) outlineThickness(2)
#define BASIC colour(56, 150, 180, 255) trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define VBASIC colour("Gainsboro") trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define FTABLES tableGridColour("Silver") tableColour:0(20,20,20,245) tableBackgroundColour("Silver")
#define BUTTONS colour:0(79,79,79,105) colour:1("MediumTurquoise") colour:0("DarkSlateGrey") fontColour("Gainsboro")
#define MIDI colour:0(96,150,170,255) colour:1("Grey") value(0) latched(0)
#define MIDIX colour:0(96,150,170,255) colour:1("red") value(0) latched(0) 
#define FONT fontColour("Gainsboro")
#define RSLIDER colour(56, 150, 180, 255) trackerColour("MediumTurquoise") fontColour("Gainsboro") valueTextBox(1) textBoxColour("black")

form channel("MVerbGUI") presetIgnore(1) caption("MVerb 3D") size(540, 495) colour(76,130,180,155) outlineColour(0,0,0,255) outlineThickness(2) pluginId("MV3D") fontColour("white") style("legacy") 

image bounds(5,5,145,230) plant("main") channel("i1") presetIgnore(1) $PLANT
{
label bounds(3,7,55,15) text("Presets") channel("l1") presetIgnore(1) $FONT

combobox bounds(5,25,130,20) populate("*.snaps") channelType("string") channel("combobox") ;$FONT
filebutton bounds(55,5,35,16) text("Save") populate("*.snaps") mode("named preset") channel("fb1") presetIgnore(1) 
filebutton bounds(90,5,50,16) text("Remove") populate("*.snaps") mode("remove preset") channel("fb2") presetIgnore(1)

button bounds(22,48,30,15) text("Size") channel("mapDFact") presetIgnore(1) $MIDI
button bounds(52,48,9,15) text("") channel("mapDFactX") presetIgnore(1) $MIDIX
rslider bounds(10,65,60,45) channel("DFact") range(.01,2,1,1,.001) $RSLIDER
button bounds(80,48,30,15) text("Decay") channel("mapFB") presetIgnore(1) $MIDI
button bounds(110,48,9,15) text("") channel("mapFBX") presetIgnore(1) $MIDIX
rslider bounds(71,65,60,45) channel("FB") range(0,1,0.925,4,0.001) $RSLIDER 
label bounds(14,115,105,15) text("Early Reflection") channel("l2") presetIgnore(1) $FONT
combobox bounds(15,135,110,20) value(2) channel("ERSelect") items("None","Small","Medium","Large","Huge","Long Random","Short Backwards","Long Backwards","Strange1","Strange2") $FONT
button bounds(50,160,30,15) text("Amp") channel("mapERamp") presetIgnore(1) $MIDI
button bounds(80,160,9,15) text("") channel("mapERampX") presetIgnore(1) $MIDIX
rslider bounds(40,175,60,45) channel("ERamp") range(0,1.5,.9,1,.001) $RSLIDER
}

image bounds(155,5,140,98) plant("EQ") channel("i2") presetIgnore(1) $PLANT
{
label bounds(5,4,40,15) text("Filter") channel("l3") presetIgnore(1) $FONT
combobox bounds(50,4,85,16) channel("filtsel") value(1) text("Low Shelf","High Shelf","Peak","Low Pass","High Pass","Band Pass","Band Reject","Bypass/Off") $FONT
button bounds(22,24,32,15) text("Freq") channel("mapf1") presetIgnore(1) $MIDI
button bounds(54,24,9,15) text("") channel("mapf1X") presetIgnore(1) $MIDIX
rslider bounds(10,40,65,45) channel("f1") range(20,20000,10000,.5,1) $RSLIDER
button bounds(85,24,32,15) text("Q") channel("mapQ") identChannel("Qa") visible(0) presetIgnore(1) $MIDI
button bounds(117,24,9,15) text("") channel("mapQX") identChannel("Qb")visible(0) presetIgnore(1) $MIDIX
rslider bounds(72,40,65,45) channel("Q") range(.5,99,.5,1,.1) identChannel("Qc") visible(0) $RSLIDER
button bounds(85,24,32,15) text("Q") channel("mapQ2") identChannel("Q2a") visible(0) presetIgnore(1) $MIDI
button bounds(117,24,9,15) text("") channel("mapQ2X") identChannel("Q2b") visible(0) presetIgnore(1) $MIDIX
rslider bounds(72,40,65,45) channel("Q2") range(.5,.999,.5,1,.001) identChannel("Q2c") visible(0) $RSLIDER
button bounds(85,24,32,15) text("boost") channel("mapboost") identChannel("boosta") visible(1) presetIgnore(1) $MIDI
button bounds(117,24,9,15) text("") channel("mapboostX") identChannel("boostb") visible(1) presetIgnore(1) $MIDIX 
rslider bounds(72,40,65,45) channel("boost") range(.5,1.5,1,1,.01) identChannel("boostc") visible(1) $RSLIDER
}

image bounds(300,5,235,50) plant("input") channel("i3") presetIgnore(1) $PLANT
{
button bounds(3,3,55,20) channel("sfplay") text("Play SF") presetIgnore(1) $BUTTONS
filebutton bounds(61,3,37,13) channel("openFile") text("Load") presetIgnore(1) $BUTTONS
button bounds(61,18,37,13) channel("sfloop") text("Loop") presetIgnore(1) $BUTTONS
button bounds(61,33,37,13) channel("sfback") text("Back") presetIgnore(1) $BUTTONS
rslider bounds(89,2,58,45) channel("sfspeed") range(.25,4,1,.5,.001) presetIgnore(1) $RSLIDER
button bounds(142,3,37,15) text("SF Speed") channel("mapsfspeed") presetIgnore(1) $MIDI
button bounds(179,3,9,15) text("") channel("mapsfspeedX") presetIgnore(1) $MIDIX
button bounds(3,26,55,20) channel("liveon") text("Mic/Line") presetIgnore(1) $BUTTONS
button bounds(142,32,37,15) text("Amp") channel("mapliveamp") presetIgnore(1) $MIDI
button bounds(179,32,9,15) text("") channel("mapliveampX") presetIgnore(1) $MIDIX
rslider bounds(180,2,58,45) channel("liveamp") range(0,5,.75,0.75,0.001) presetIgnore(1) $RSLIDER
}

image bounds(300,58,235,45) plant("MeshIn") channel("i4") presetIgnore(1) $PLANT
{
label bounds(10,16,20,12) text("In") channel("l4") presetIgnore(1) $FONT
label bounds(5,3,30,12) text("1-4") channel("l5") presetIgnore(1) $FONT
label bounds(5,29,30,12) text("5-8") channel("l6") presetIgnore(1) $FONT
combobox bounds(40,4,38,16) channel("in1") value(2) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(85,4,38,16) channel("in2") value(4) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(130,4,38,16) channel("in3") value(6) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(175,4,38,16) channel("in4") value(10) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(40,25,38,16) channel("in5") value(16) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(85,25,38,16) channel("in6") value(20) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(130,25,38,16) channel("in7") value(22) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(175,25,38,16) channel("in8") value(24) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
}

image bounds(5,240,145,100) plant("randomize") channel("i5") presetIgnore(1) $PLANT
{
button bounds(22,5,100,20) channel("random") text("Moving Mesh") $BUTTONS
button bounds(6,30,35,15) text("Range") channel("maprmax") presetIgnore(1) $MIDI
button bounds(41,30,9,15) text("") channel("maprmaxX") presetIgnore(1) $MIDIX
rslider bounds(0,48,60,45) channel("rmax") range(0,.95,.1,1,.01) $RSLIDER
button bounds(53,30,30,15) text("Rate") channel("maprrate") presetIgnore(1) $MIDI
button bounds(84,30,9,15) text("") channel("maprrateX") presetIgnore(1) $MIDIX
rslider bounds(43,48,60,45) channel("rrate") range(.05,250,.5,.25,.01) $RSLIDER
button bounds(95,30,30,15) text("R Dev") channel("maprratedev") presetIgnore(1) $MIDI
button bounds(126,30,9,15) text("") channel("maprratedevX") presetIgnore(1) $MIDIX
rslider bounds(84,48,60,45) channel("rratedev") range(0,.95,.1,1,.01) $RSLIDER
}

image bounds(5,345,145,90) plant("surprise") channel("i6") presetIgnore(1) $PLANT
{
button bounds(8,5,130,20) channel("randres") text("Random Resonances") latched(0) presetIgnore(1) $BUTTONS
rslider bounds(5,30,75,55) channel("low") range(2,20000,20,.5,.1) valueTextBox(1) text("Low F") textColour("Gainsboro") $RSLIDER
rslider bounds(80,30,75,55) channel("high") range(2,20000,10000,.5,.1) valueTextBox(1) text("High F") textColour("Gainsboro") $RSLIDER
}

image bounds(155,107,380,328) plant("ResF") channel("i7") presetIgnore(1) $PLANT
{
label bounds(35,5,300,15) text("4x4x3 mesh reverb resonant frequencies") channel("l7") presetIgnore(1) $FONT
label bounds(40,32,70,15) text("341-344") channel("l8") presetIgnore(1) $FONT
label bounds(30,52,70,15) text("331-334") channel("l9") presetIgnore(1) $FONT
label bounds(20,72,70,15) text("321-324") channel("l10") presetIgnore(1) $FONT
label bounds(10,92,70,15) text("311-314") channel("l11") presetIgnore(1) $FONT
label bounds(40,122,70,15) text("241-244") channel("l12") presetIgnore(1) $FONT
label bounds(30,142,70,15) text("231-234") channel("l13") presetIgnore(1) $FONT
label bounds(20,162,70,15) text("221-224") channel("l14") presetIgnore(1) $FONT
label bounds(10,182,70,15) text("211-214") channel("l15") presetIgnore(1) $FONT
label bounds(40,212,70,15) text("141-144") channel("l16") presetIgnore(1) $FONT
label bounds(30,232,70,15) text("131-134") channel("l17") presetIgnore(1) $FONT
label bounds(20,252,70,15) text("121-124") channel("l18") presetIgnore(1) $FONT
label bounds(10,272,70,15) text("111-114") channel("l19") presetIgnore(1) $FONT
nslider bounds(115,30,60,20) channel("res341") range(2,20000,159.3,0.5,0.01) value(159.3) $FONT
nslider bounds(180,30,60,20) channel("res342") range(2,20000,401.5,0.5,0.01) value(401.5) $FONT
nslider bounds(245,30,60,20) channel("res343") range(2,20000,733,0.5,0.01) value(733) $FONT
nslider bounds(310,30,60,20) channel("res344") range(2,20000,1010,0.5,0.01) value(1010) $FONT
nslider bounds(105,50,60,20) channel("res331") range(2,20000,183,0.5,0.01) value(183) $FONT
nslider bounds(170,50,60,20) channel("res332") range(2,20000,578,0.5,0.01) value(578) $FONT
nslider bounds(235,50,60,20) channel("res333") range(2,20000,313,0.5,0.01) value(313) $FONT
nslider bounds(300,50,60,20) channel("res334") range(2,20000,792,0.5,0.01) value(792) $FONT
nslider bounds(95,70,60,20) channel("res321") range(2,20000,842,0.5,0.01) value(842) $FONT
nslider bounds(160,70,60,20) channel("res322") range(2,20000,999,0.5,0.01) value(999) $FONT
nslider bounds(225,70,60,20) channel("res323") range(2,20000,621,0.5,0.01) value(621) $FONT
nslider bounds(290,70,60,20) channel("res324") range(2,20000,210,0.5,0.01) value(210) $FONT
nslider bounds(85,90,60,20) channel("res311") range(2,20000,114.3,0.5,0.01) value(114.3) $FONT
nslider bounds(150,90,60,20) channel("res312") range(2,20000,963.2,0.5,0.01) value(963.2) $FONT
nslider bounds(215,90,60,20) channel("res313") range(2,20000,250.3,0.5,0.01) value(250.3) $FONT
nslider bounds(280,90,60,20) channel("res314") range(2,20000,373.73,0.5,0.01) value(373.73) $FONT
nslider bounds(115,120,60,20) channel("res241") range(2,20000,669.2,0.5,0.01) value(669.2) $FONT
nslider bounds(180,120,60,20) channel("res242") range(2,20000,739.7,0.5,0.01) value(739.7) $FONT
nslider bounds(245,120,60,20) channel("res243") range(2,20000,843.6,0.5,0.01) value(843.6) $FONT
nslider bounds(310,120,60,20) channel("res244") range(2,20000,272.72,0.5,0.01) value(272.72) $FONT
nslider bounds(105,140,60,20) channel("res231") range(2,20000,435,0.5,0.01) value(435) $FONT
nslider bounds(170,140,60,20) channel("res232") range(2,20000,735,0.5,0.01) value(735) $FONT
nslider bounds(235,140,60,20) channel("res233") range(2,20000,76.8,0.5,0.01) value(76.8) $FONT
nslider bounds(300,140,60,20) channel("res234") range(2,20000,114,0.5,0.01) value(114) $FONT
nslider bounds(95,160,60,20) channel("res221") range(2,20000,792,0.5,0.01) value(792) $FONT
nslider bounds(160,160,60,20) channel("res222") range(2,20000,159.3,0.5,0.01) value(159.3) $FONT
nslider bounds(225,160,60,20) channel("res223") range(2,20000,401.5,0.5,0.01) value(401.5) $FONT
nslider bounds(290,160,60,20) channel("res224") range(2,20000,102,0.5,0.01) value(102) $FONT
nslider bounds(85,180,60,20) channel("res211") range(2,20000,210,0.5,0.01) value(210) $FONT
nslider bounds(150,180,60,20) channel("res212") range(2,20000,183,0.5,0.01) value(183) $FONT
nslider bounds(215,180,60,20) channel("res213") range(2,20000,578,0.5,0.01) value(578) $FONT
nslider bounds(280,180,60,20) channel("res214") range(2,20000,313,0.5,0.01) value(313) $FONT
nslider bounds(115,210,60,20) channel("res141") range(2,20000,373.73,0.5,0.01) value(373.73) $FONT
nslider bounds(180,210,60,20) channel("res142") range(2,20000,842,0.5,0.01) value(842) $FONT
nslider bounds(245,210,60,20) channel("res143") range(2,20000,999,0.5,0.01) value(999) $FONT
nslider bounds(310,210,60,20) channel("res144") range(2,20000,621,0.5,0.01) value(621) $FONT
nslider bounds(105,230,60,20) channel("res131") range(2,20000,272.72,0.5,0.01) value(272.72) $FONT
nslider bounds(170,230,60,20) channel("res132") range(2,20000,114.3,0.5,0.01) value(114.3) $FONT
nslider bounds(235,230,60,20) channel("res133") range(2,20000,963.2,0.5,0.01) value(963.2) $FONT
nslider bounds(300,230,60,20) channel("res134") range(2,20000,250.3,0.5,0.01) value(250.3) $FONT
nslider bounds(95,250,60,20) channel("res121") range(2,20000,114,0.5,0.01) value(114) $FONT
nslider bounds(160,250,60,20) channel("res122") range(2,20000,669.2,0.5,0.01) value(669.2) $FONT
nslider bounds(225,250,60,20) channel("res123") range(2,20000,739.7,0.5,0.01) value(739.7) $FONT
nslider bounds(290,250,60,20) channel("res124") range(2,20000,843.6,0.5,0.01) value(843.6) $FONT
nslider bounds(85,270,60,20) channel("res111") range(2,20000,102,0.5,0.01) value(102) $FONT
nslider bounds(150,270,60,20) channel("res112") range(2,20000,435,0.5,0.01) value(435) $FONT
nslider bounds(215,270,60,20) channel("res113") range(2,20000,735,0.5,0.01) value(735) $FONT
nslider bounds(280,270,60,20) channel("res114") range(2,20000,76.8,0.5,0.01) value(76.8) $FONT
rslider bounds(20,295,30,30) channel("port") range(.01,10,.5,.5,.01) colour(56, 150, 180, 255) trackerColour("MediumTurquoise") textColour("white") 
button bounds(55,307,62,15) text("Portamento") channel("mapport") presetIgnore(1) $MIDI
button bounds(117,307,9,15) text("") channel("mapportX") presetIgnore(1) $MIDIX
rslider bounds(140,295,30,30) channel("disp") range(0,.95,.375,1,.001) colour(56, 150, 180, 255) trackerColour("MediumTurquoise") textColour("white")
button bounds(175,292,25,14) channel("dispon") text("off","on") value(1) $BUTTONS 
button bounds(175,307,62,15) text("Dispersion") channel("mapdisp") presetIgnore(1) $MIDI
button bounds(237,307,9,15) text("") channel("mapdispX") presetIgnore(1) $MIDIX
button bounds(265,303,105,20) channel("FBclear") text("Anti-Feedback") latched(1) presetIgnore(1) $BUTTONS
}

image bounds(5,440,145,50) plant("mix") channel("i8") presetIgnore(1) $PLANT
{
button bounds(75,15,27,15) text("Mix") channel("mapmix") presetIgnore(1) $MIDI
button bounds(102,15,9,15) text("") channel("mapmixX") presetIgnore(1) $MIDIX
rslider bounds(25,2,55,45) channel("mix") range(0,1,0.75,1,0.001) value(0.75) $RSLIDER
}

image bounds(155,440,140,50) plant("record") channel("i9") presetIgnore(1) $PLANT
{
button bounds(5,3,62,20) channel("record") text("Record","Stop") presetIgnore(1) $BUTTONS
button bounds(70,3,62,20) channel("play") text("Play") presetIgnore(1) $BUTTONS
combobox bounds(7,25,58,16) channel("recch") value(2) text("mono","stereo","3 channel","4 channel","5 channel","6 channel","7 channel","8 channel") presetIgnore(1) $FONT
combobox bounds(72,25,58,16) channel("bit") value(1) text("16-bit","24-bit","32-bit") presetIgnore(1) $FONT
}

image bounds(300,440,235,50) plant("MeshOut") channel("i10") presetIgnore(1) $PLANT
{
label bounds(10,18,20,12) text("Out") channel("l20") presetIgnore(1) $FONT
label bounds(5,5,30,12) text("1-4") channel("l21") presetIgnore(1) $FONT
label bounds(5,31,30,12) text("5-8") channel("l22") presetIgnore(1) $FONT
combobox bounds(40,6,38,16) channel("out1") value(2) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(85,6,38,16) channel("out2") value(4) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(130,6,38,16) channel("out3") value(6) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(175,6,38,16) channel("out4") value(10) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(40,28,38,16) channel("out5") value(16) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(85,28,38,16) channel("out6") value(20) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(130,28,38,16) channel("out7") value(22) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
combobox bounds(175,28,38,16) channel("out8") value(24) text("111","112","113","114","121","122","123","124","131","132","133","134","141","142","143","144","211","212","213","214","221","222","223","224","231","232","233","234","241","242","243","244","311","312","313","314","321","322","323","324","331","332","333","334","341","342","343","344") $FONT
}

</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-d -n -+rtmidi=NULL -M0 -m0d
</CsOptions>
<CsInstruments>

;sr = 44100
ksmps = 50
nchnls = 8
0dbfs = 1

ga1mix,ga2mix,ga3mix,ga4mix,ga5mix,ga6mix,ga7mix,ga8mix init 0
garev1,garev2,garev3,garev4,garev5,garev6,garev7,garev8 init 0
gamic1,gamic2,gamic3,gamic4,gamic5,gamic6,gamic7,gamic8 init 0
gichnls,giReady,gifilelen init 0 ;globals for soundfile table loading
gSfilepath init ""
giTable init 500
gkTabLen init 2
gkRecordingActiveFlag,gkFileRecorded init 0

opcode Alpaz, a,aki
a1, kg1, iM1 xin
adel1 init   0
aout = adel1+(-kg1*a1)
adel1 delay  a1+(kg1*aout), iM1 
xout aout
endop

opcode EQ,a,a ;1 audio out, 1 audio in ;get k-rate data through chnget arguments
ain	xin
kfiltsel chnget "filtsel"
kboost    chnget  "boost"
kboost    port    2-kboost,.05
kf1 chnget "f1"
kf1 port kf1,.05
kQ chnget "Q"
kQ port kQ,.05
if kfiltsel==1 then
afilt    pareq    ain,kf1,kboost,.5,1
elseif kfiltsel==2 then
afilt    pareq    ain,kf1,kboost,.5,2
elseif kfiltsel==3 then
afilt    pareq    ain,kf1,kboost,kQ,0
elseif kfiltsel==4 then
afilt    tone     ain,kf1
elseif kfiltsel==5 then
afilt    atone    ain,kf1
elseif kfiltsel==6 then
afilt    reson    ain,kf1,kf1/(kQ*.1)
elseif kfiltsel==7 then
afilt    areson   ain,kf1,kf1/(kQ*.1)
elseif kfiltsel==8 then
afilt=ain
endif
aout balance  afilt,ain ;feedback without the balance embeded
aout dcblock2 aout
xout    aout
endop

opcode  meshEQ,aaaaaaa,aaaaaaaak ;7 audio outs and 8 audio ins one k-rate in for FB value, use for boundary nodes
aina,ainb,ainc,aind,aine,ainf,ains,adel,kFB xin ;a=12:00, b=3:00, c=6:00, d=9:00, e=up, f=down, s=source input, del=delay
afactor=(aina+ainb+ainc+aind+aine+ainf+ains)*-.3333	;calculate raw value
aouta   vdelay  aina+afactor,adel,1000	;calculate outputs
aoutb   vdelay  ainb+afactor,adel,1000
aoutc   vdelay  ainc+afactor,adel,1000
aoutd   vdelay  aind+afactor,adel,1000
aoute   vdelay  aine+afactor,adel,1000
aoutf   vdelay  ainf+afactor,adel,1000
aouta   EQ  aouta  ;apply EQ on each output
aoutb   EQ  aoutb
aoutc   EQ  aoutc
aoutd   EQ  aoutd
aoute   EQ  aoute
aoutf   EQ  aoutf
kalpg chnget "disp"
kdispon chnget "dispon"
if kdispon==0 goto OUT
aouta Alpaz aouta, kalpg, random(0.005,0.075)
aoutb Alpaz aoutb, kalpg, random(0.005,0.075)
aoutc Alpaz aoutc, kalpg, random(0.005,0.075)
aoutd Alpaz aoutd, kalpg, random(0.005,0.075)
aoute Alpaz aoute, kalpg, random(0.005,0.075)
aoutf Alpaz aoutf, kalpg, random(0.005,0.075)
OUT:
xout	aouta*kFB,aoutb*kFB,aoutc*kFB,aoutd*kFB,aoute*kFB,aoutf*kFB,afactor ;afactor serves as the audio tap for output
endop

opcode randomdel,a,a
adel xin
krand chnget "random"
krrate chnget "rrate"
krrate port krrate,.05
krratedev chnget "rratedev"
krratedev port krratedev,.05
krmax chnget "rmax"
krmax port krmax,.05
if krand=1 then
krdev=krrate*krratedev
krdev2 randh krdev,krrate,2 ;calculate random cps
adelayA randi krmax,krrate+krdev,2 
adel=adel+(adel*adelayA)
else
xout adel
endif
endop

instr 1 ;activate live audio input 
kliveon chnget "liveon"
if changed(kliveon) == 1 then
  if kliveon=1 then
  turnoff2 4,2,0
  event "i",4,0,999999
  else 
  turnoff2 4,2,0
  endif
endif

kplay   chnget  "sfplay"
gSfilepath chnget "openFile"
    
if changed(gSfilepath) == 1 then ;loads soundfile
    SIdentString sprintfk "file(\"%s\")", gSfilepath
    chnset SIdentString, "SFfiler"
    event   "i",3,0,0
endif
        
if changed(kplay) == 1 then ;turns on soundfile player
    if kplay=1 then 
    event "i",2,0,10000
    else
    turnoff2  2,0,.05
    endif
endif

gkrecord	chnget	"record"
gkplay		chnget	"play"
kRecStart	trigger	gkrecord,0.5,0
  if kRecStart==1 && gkRecordingActiveFlag==0 then
    event	"i",60,0,-1
    gkRecordingActiveFlag	=	1
  endif
  kPlayStart	trigger	gkplay,0.5,0
  if kPlayStart==1 && gkFileRecorded==1 then
    event	"i",61,ksmps/sr,3600
  endif
  
krandres chnget "randres"
if changed(krandres)==1 then
  if krandres=1 then
  event "i",6,0,.001
  endif
endif

;filter GUI visible controls follow:
kfiltsel chnget "filtsel"
if changed(kfiltsel)==1 then
 if kfiltsel=1 then
  chnset "visible(1)", "boosta"
  chnset "visible(1)", "boostb"
  chnset "visible(1)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(0)", "Q2a"
  chnset "visible(0)", "Q2b"
  chnset "visible(0)", "Q2c"
 elseif kfiltsel=2 then
  chnset "visible(1)", "boosta"
  chnset "visible(1)", "boostb"
  chnset "visible(1)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(0)", "Q2a"
  chnset "visible(0)", "Q2b"
  chnset "visible(0)", "Q2c"
 elseif kfiltsel=3 then
  chnset "visible(0)", "boosta"
  chnset "visible(0)", "boostb"
  chnset "visible(0)", "boostc"
  chnset "visible(1)", "Qa"
  chnset "visible(1)", "Qb"
  chnset "visible(1)", "Qc"
  chnset "visible(0)", "Q2a"
  chnset "visible(0)", "Q2b"
  chnset "visible(0)", "Q2c"
 elseif kfiltsel=4 then
  chnset "visible(0)", "boosta"
  chnset "visible(0)", "boostb"
  chnset "visible(0)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(0)", "Q2a"
  chnset "visible(0)", "Q2b"
  chnset "visible(0)", "Q2c"
 elseif kfiltsel=5 then
  chnset "visible(0)", "boosta"
  chnset "visible(0)", "boostb"
  chnset "visible(0)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(0)", "Q2a"
  chnset "visible(0)", "Q2b"
  chnset "visible(0)", "Q2c"
 elseif kfiltsel=6 then
  chnset "visible(0)", "boosta"
  chnset "visible(0)", "boostb"
  chnset "visible(0)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(1)", "Q2a"
  chnset "visible(1)", "Q2b"
  chnset "visible(1)", "Q2c"
 elseif kfiltsel=7 then
  chnset "visible(0)", "boosta"
  chnset "visible(0)", "boostb"
  chnset "visible(0)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(1)", "Q2a"
  chnset "visible(1)", "Q2b"
  chnset "visible(1)", "Q2c"
 endif
endif     
endin

instr 2
kloop chnget "sfloop"
iloop=i(kloop)
kingain chnget  "liveamp"
kEnv linsegr 0,.05,1,p3-.05,1,.1,0
ksfspeed chnget "sfspeed"
ksfspeed port ksfspeed,.005
ksfback chnget "sfback"
if ksfback==0 then
 if gichnls==1 then
    a1	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==2 then
    a1,a2	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==3 then
    a1,a2,a3	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==4 then
   a1,a2,a3,a4	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==5 then
   a1,a2,a3,a4,a5	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==6 then
   a1,a2,a3,a4,a5,a6	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==7 then
   a1,a2,a3,a4,a5,a6,a7	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==8 then
   a1,a2,a3,a4,a5,a6,a7,a8	diskin2	gSfilepath,ksfspeed,0,iloop
 endif
elseif ksfback==1 then
 if gichnls==1 then
    a1	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==2 then
    a1,a2	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==3 then
    a1,a2,a3	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==4 then
   a1,a2,a3,a4	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==5 then
   a1,a2,a3,a4,a5	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==6 then
   a1,a2,a3,a4,a5,a6	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==7 then
   a1,a2,a3,a4,a5,a6,a7	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==8 then
   a1,a2,a3,a4,a5,a6,a7,a8	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 endif
endif
asf1=a1*kingain*kEnv
asf2=a2*kingain*kEnv
asf3=a3*kingain*kEnv
asf4=a4*kingain*kEnv
asf5=a5*kingain*kEnv
asf6=a6*kingain*kEnv
asf7=a7*kingain*kEnv
asf8=a8*kingain*kEnv
ga1mix=asf1+ga1mix 
ga2mix=asf2+ga2mix
ga3mix=asf3+ga3mix 
ga4mix=asf4+ga4mix
ga5mix=asf5+ga5mix 
ga6mix=asf6+ga6mix
ga7mix=asf7+ga7mix 
ga8mix=asf8+ga8mix
endin

instr 3
gichnls filenchnls  gSfilepath
gifilelen filelen gSfilepath
giReady=1 ;default if no string has been loaded yet
gkTabLen init ftlen(giTable)/gichnls
Smessage sprintfk "file(%s)",gSfilepath
endin

instr 4 ;live audio input
kliveamp chnget "liveamp"

ain1,ain2,ain3,ain4,ain5,ain6,ain7,ain8 ino ;mic/live audio inputs
ain1=ain1*kliveamp
ain2=ain2*kliveamp
ain3=ain3*kliveamp
ain4=ain4*kliveamp
ain5=ain5*kliveamp
ain6=ain6*kliveamp
ain7=ain7*kliveamp
ain8=ain8*kliveamp

ga1mix=dcblock2(ga1mix+ain1)  ;add into global audio mix
ga2mix=dcblock2(ga2mix+ain2)
ga3mix=dcblock2(ga3mix+ain3)
ga4mix=dcblock2(ga4mix+ain4)
ga5mix=dcblock2(ga5mix+ain5)
ga6mix=dcblock2(ga6mix+ain6)
ga7mix=dcblock2(ga7mix+ain7)
ga8mix=dcblock2(ga8mix+ain8)
endin

instr 5 ;global live/FX mix 
gkFX  chnget  "mix"
gksource=1-gkFX
endin

instr 6 ;generate random delay values within set range
klow chnget "low"
khigh chnget "high"
if klow>khigh then
ktemp=khigh
khigh=klow
klow=ktemp
endif
chnset random(klow,khigh),"res111"	  
chnset random(klow,khigh),"res112"    
chnset random(klow,khigh),"res113"   
chnset random(klow,khigh),"res114"
chnset random(klow,khigh),"res121"
chnset random(klow,khigh),"res122"  
chnset random(klow,khigh),"res123"
chnset random(klow,khigh),"res124"
chnset random(klow,khigh),"res131"
chnset random(klow,khigh),"res132"
chnset random(klow,khigh),"res133"   
chnset random(klow,khigh),"res134"   
chnset random(klow,khigh),"res141" 
chnset random(klow,khigh),"res142" 
chnset random(klow,khigh),"res143"
chnset random(klow,khigh),"res144" 
chnset random(klow,khigh),"res211"	  
chnset random(klow,khigh),"res212"    
chnset random(klow,khigh),"res213"   
chnset random(klow,khigh),"res214"
chnset random(klow,khigh),"res221"
chnset random(klow,khigh),"res222"  
chnset random(klow,khigh),"res223"
chnset random(klow,khigh),"res224"
chnset random(klow,khigh),"res231"
chnset random(klow,khigh),"res232"
chnset random(klow,khigh),"res233"   
chnset random(klow,khigh),"res234"   
chnset random(klow,khigh),"res241" 
chnset random(klow,khigh),"res242" 
chnset random(klow,khigh),"res243"
chnset random(klow,khigh),"res244" 
chnset random(klow,khigh),"res311"	  
chnset random(klow,khigh),"res312"    
chnset random(klow,khigh),"res313"   
chnset random(klow,khigh),"res314"
chnset random(klow,khigh),"res321"
chnset random(klow,khigh),"res322"  
chnset random(klow,khigh),"res323"
chnset random(klow,khigh),"res324"
chnset random(klow,khigh),"res331"
chnset random(klow,khigh),"res332"
chnset random(klow,khigh),"res333"   
chnset random(klow,khigh),"res334"   
chnset random(klow,khigh),"res341" 
chnset random(klow,khigh),"res342" 
chnset random(klow,khigh),"res343"
chnset random(klow,khigh),"res344" 
endin

instr 10    ;5x5 mesh
;make multi-channel options both for sound input and output

a111a,a111b,a111c,a111d,a111e,a111f,a111s init 0 ;initialize all inputs for mesh
a112a,a112b,a112c,a112d,a112e,a112f,a112s init 0
a113a,a113b,a113c,a113d,a113e,a113f,a113s init 0
a114a,a114b,a114c,a114d,a114e,a114f,a114s init 0
a121a,a121b,a121c,a121d,a121e,a121f,a121s init 0
a122a,a122b,a122c,a122d,a122e,a122f,a122s init 0
a123a,a123b,a123c,a123d,a123e,a123f,a123s init 0
a124a,a124b,a124c,a124d,a124e,a124f,a124s init 0
a131a,a131b,a131c,a131d,a131e,a131f,a131s init 0
a132a,a132b,a132c,a132d,a132e,a132f,a132s init 0
a133a,a133b,a133c,a133d,a133e,a133f,a133s init 0
a134a,a134b,a134c,a134d,a134e,a134f,a134s init 0
a141a,a141b,a141c,a141d,a141e,a141f,a141s init 0
a142a,a142b,a142c,a142d,a142e,a142f,a142s init 0
a143a,a143b,a143c,a143d,a143e,a143f,a143s init 0
a144a,a144b,a144c,a144d,a144e,a144f,a144s init 0
a211a,a211b,a211c,a211d,a211e,a211f,a211s init 0
a212a,a212b,a212c,a212d,a212e,a212f,a212s init 0
a213a,a213b,a213c,a213d,a213e,a213f,a213s init 0
a214a,a214b,a214c,a214d,a214e,a214f,a214s init 0
a221a,a221b,a221c,a221d,a221e,a221f,a221s init 0
a222a,a222b,a222c,a222d,a222e,a222f,a222s init 0
a223a,a223b,a223c,a223d,a223e,a223f,a223s init 0
a224a,a224b,a224c,a224d,a224e,a224f,a224s init 0
a231a,a231b,a231c,a231d,a231e,a231f,a231s init 0
a232a,a232b,a232c,a232d,a232e,a232f,a232s init 0
a233a,a233b,a233c,a233d,a233e,a233f,a233s init 0
a234a,a234b,a234c,a234d,a234e,a234f,a234s init 0
a241a,a241b,a241c,a241d,a241e,a241f,a241s init 0
a242a,a242b,a242c,a242d,a242e,a242f,a242s init 0
a243a,a243b,a243c,a243d,a243e,a243f,a243s init 0
a244a,a244b,a244c,a244d,a244e,a244f,a244s init 0
a311a,a311b,a311c,a311d,a311e,a311f,a311s init 0
a312a,a312b,a312c,a312d,a312e,a312f,a312s init 0
a313a,a313b,a313c,a313d,a313e,a313f,a313s init 0
a314a,a314b,a314c,a314d,a314e,a314f,a314s init 0
a321a,a321b,a321c,a321d,a321e,a321f,a321s init 0
a322a,a322b,a322c,a322d,a322e,a322f,a322s init 0
a323a,a323b,a323c,a323d,a323e,a323f,a323s init 0
a324a,a324b,a324c,a324d,a324e,a324f,a324s init 0
a331a,a331b,a331c,a331d,a331e,a331f,a331s init 0
a332a,a332b,a332c,a332d,a332e,a332f,a332s init 0
a333a,a333b,a333c,a333d,a333e,a333f,a333s init 0
a334a,a334b,a334c,a334d,a334e,a334f,a334s init 0
a341a,a341b,a341c,a341d,a341e,a341f,a341s init 0
a342a,a342b,a342c,a342d,a342e,a342f,a342s init 0
a343a,a343b,a343c,a343d,a343e,a343f,a343s init 0
a344a,a344b,a344c,a344d,a344e,a344f,a344s init 0

kDFact  chnget  "DFact"
kDFact  port    kDFact,.25
kFB chnget  "FB"
kFB port    kFB,.25
;;;"clear delays" coefficient
kdelclear   chnget  "FBclear"
kdelclear   port    kdelclear,.1
kFB=kFB*(1-kdelclear)
kER chnget "ERSelect"
kERamp chnget "ERamp"

;channels: random (on/off), rslow, rfast, rmax 
kport chnget "port"
kres111   chnget  "res111"
kres111 portk kres111,kport
adel111=kDFact*(1000/kres111)
adel111 randomdel adel111
kres112   chnget  "res112"
kres112 portk kres112,kport
adel112=kDFact*(1000/kres112)
adel112 randomdel adel112
kres113   chnget  "res113"
kres113 portk kres113,kport
adel113=kDFact*(1000/kres113)
adel113 randomdel adel113
kres114   chnget  "res114"
kres114 portk kres114,kport
adel114=kDFact*(1000/kres114)
adel114 randomdel adel114
kres121   chnget  "res121"
kres121 portk kres121,kport
adel121=kDFact*(1000/kres121)
adel121 randomdel adel121
kres122   chnget  "res122"
kres122 portk kres122,kport
adel122=kDFact*(1000/kres122)
adel122 randomdel adel122
kres123   chnget  "res123"
kres123 portk kres123,kport
adel123=kDFact*(1000/kres123)
adel123 randomdel adel123
kres124   chnget  "res124"
kres124 portk kres124,kport
adel124=kDFact*(1000/kres124)
adel124 randomdel adel124
kres131   chnget  "res131"
kres131 portk kres131,kport
adel131=kDFact*(1000/kres131)
adel131 randomdel adel131
kres132   chnget  "res132"
kres132 portk kres132,kport
adel132=kDFact*(1000/kres132)
adel132 randomdel adel132
kres133   chnget  "res133"
kres133 portk kres133,kport
adel133=kDFact*(1000/kres133)
adel133 randomdel adel133
kres134   chnget  "res134"
kres134 portk kres134,kport
adel134=kDFact*(1000/kres134)
adel134 randomdel adel134
kres141   chnget  "res141"
kres141 portk kres141,kport
adel141=kDFact*(1000/kres141)
adel141 randomdel adel141
kres142   chnget  "res142"
kres142 portk kres142,kport
adel142=kDFact*(1000/kres142)
adel142 randomdel adel142
kres143   chnget  "res143"
kres143 portk kres143,kport
adel143=kDFact*(1000/kres143)
adel143 randomdel adel143
kres144   chnget  "res144"
kres144 portk kres144,kport
adel144=kDFact*(1000/kres144)
adel144 randomdel adel144
kres211   chnget  "res211"
kres211 portk kres211,kport
adel211=kDFact*(1000/kres211)
adel211 randomdel adel211
kres212   chnget  "res212"
kres212 portk kres212,kport
adel212=kDFact*(1000/kres212)
adel212 randomdel adel212
kres213   chnget  "res213"
kres213 portk kres213,kport
adel213=kDFact*(1000/kres213)
adel213 randomdel adel213
kres214   chnget  "res214"
kres214 portk kres214,kport
adel214=kDFact*(1000/kres214)
adel214 randomdel adel214
kres221   chnget  "res221"
kres221 portk kres221,kport
adel221=kDFact*(1000/kres221)
adel221 randomdel adel221
kres222   chnget  "res222"
kres222 portk kres222,kport
adel222=kDFact*(1000/kres222)
adel222 randomdel adel222
kres223   chnget  "res223"
kres223 portk kres223,kport
adel223=kDFact*(1000/kres223)
adel223 randomdel adel223
kres224   chnget  "res224"
kres224 portk kres224,kport
adel224=kDFact*(1000/kres224)
adel224 randomdel adel224
kres231   chnget  "res231"
kres231 portk kres231,kport
adel231=kDFact*(1000/kres231)
adel231 randomdel adel231
kres232   chnget  "res232"
kres232 portk kres232,kport
adel232=kDFact*(1000/kres232)
adel232 randomdel adel232
kres233   chnget  "res233"
kres233 portk kres233,kport
adel233=kDFact*(1000/kres233)
adel233 randomdel adel233
kres234   chnget  "res234"
kres234 portk kres234,kport
adel234=kDFact*(1000/kres234)
adel234 randomdel adel234
kres241   chnget  "res241"
kres241 portk kres241,kport
adel241=kDFact*(1000/kres241)
adel241 randomdel adel241
kres242   chnget  "res242"
kres242 portk kres242,kport
adel242=kDFact*(1000/kres242)
adel242 randomdel adel242
kres243   chnget  "res243"
kres243 portk kres243,kport
adel243=kDFact*(1000/kres243)
adel243 randomdel adel243
kres244   chnget  "res244"
kres244 portk kres244,kport
adel244=kDFact*(1000/kres244)
adel244 randomdel adel244
kres311   chnget  "res311"
kres311 portk kres311,kport
adel311=kDFact*(1000/kres311)
adel311 randomdel adel311
kres312   chnget  "res312"
kres312 portk kres312,kport
adel312=kDFact*(1000/kres312)
adel312 randomdel adel312
kres313   chnget  "res313"
kres313 portk kres313,kport
adel313=kDFact*(1000/kres313)
adel313 randomdel adel313
kres314   chnget  "res314"
kres314 portk kres314,kport
adel314=kDFact*(1000/kres314)
adel314 randomdel adel314
kres321   chnget  "res321"
kres321 portk kres321,kport
adel321=kDFact*(1000/kres321)
adel321 randomdel adel321
kres322   chnget  "res322"
kres322 portk kres322,kport
adel322=kDFact*(1000/kres322)
adel322 randomdel adel322
kres323   chnget  "res323"
kres323 portk kres323,kport
adel323=kDFact*(1000/kres323)
adel323 randomdel adel323
kres324   chnget  "res324"
kres324 portk kres324,kport
adel324=kDFact*(1000/kres324)
adel324 randomdel adel324
kres331   chnget  "res331"
kres331 portk kres331,kport
adel331=kDFact*(1000/kres331)
adel331 randomdel adel331
kres332   chnget  "res332"
kres332 portk kres332,kport
adel332=kDFact*(1000/kres332)
adel332 randomdel adel332
kres333   chnget  "res333"
kres333 portk kres333,kport
adel333=kDFact*(1000/kres333)
adel333 randomdel adel333
kres334   chnget  "res334"
kres334 portk kres334,kport
adel334=kDFact*(1000/kres334)
adel334 randomdel adel334
kres341   chnget  "res341"
kres341 portk kres341,kport
adel341=kDFact*(1000/kres341)
adel341 randomdel adel341
kres342   chnget  "res342"
kres342 portk kres342,kport
adel342=kDFact*(1000/kres342)
adel342 randomdel adel342
kres343   chnget  "res343"
kres343 portk kres343,kport
adel343=kDFact*(1000/kres343)
adel343 randomdel adel343
kres344   chnget  "res344"
kres344 portk kres344,kport
adel344=kDFact*(1000/kres344)
adel344 randomdel adel344

;10 Early Reflection choices"None", "Small","Medium","Large","Huge","Long Random",
;"Short Backwards","Long Backwards","Strange1","Strange2"

if kER=1 then   ;none
aL=0
aR=0
elseif kER=2 then   ;small
aL  multitap    ga1mix*kERamp,0.0070 , 0.5281 , 0.0156 , 0.5038 , 0.0233 , 0.3408 , 0.0287 , 0.1764 , 0.0362 , 0.2514 , 0.0427 , 0.1855 , 0.0475 , 0.2229 , 0.0526 , 0.1345 , 0.0567 , 0.1037 , 0.0616 , 0.0837 , 0.0658 , 0.0418 , 0.0687 , 0.0781 , 0.0727 , 0.0654 , 0.0762 , 0.0369 , 0.0796 , 0.0192 , 0.0817 , 0.0278 , 0.0839 , 0.0132 , 0.0862 , 0.0073 , 0.0888 , 0.0089 , 0.0909 , 0.0087 , 0.0924 , 0.0065 , 0.0937 , 0.0015 , 0.0957 , 0.0019 , 0.0968 , 0.0012 , 0.0982 , 0.0004
aR  multitap    ga2mix*kERamp,0.0097 , 0.3672 , 0.0147 , 0.3860 , 0.0208 , 0.4025 , 0.0274 , 0.3310 , 0.0339 , 0.2234 , 0.0383 , 0.1326 , 0.0441 , 0.1552 , 0.0477 , 0.1477 , 0.0533 , 0.2054 , 0.0582 , 0.1242 , 0.0631 , 0.0707 , 0.0678 , 0.1061 , 0.0702 , 0.0331 , 0.0735 , 0.0354 , 0.0758 , 0.0478 , 0.0778 , 0.0347 , 0.0814 , 0.0185 , 0.0836 , 0.0157 , 0.0855 , 0.0197 , 0.0877 , 0.0171 , 0.0902 , 0.0078 , 0.0915 , 0.0032 , 0.0929 , 0.0026 , 0.0947 , 0.0014 , 0.0958 , 0.0018 , 0.0973 , 0.0007 , 0.0990 , 0.0007
elseif kER=3 then   ;medium
aL  multitap    ga1mix*kERamp,0.0215 , 0.3607 , 0.0435 , 0.2480 , 0.0566 , 0.3229 , 0.0691 , 0.5000 , 0.0842 , 0.1881 , 0.1010 , 0.2056 , 0.1140 , 0.1224 , 0.1224 , 0.3358 , 0.1351 , 0.3195 , 0.1442 , 0.2803 , 0.1545 , 0.1909 , 0.1605 , 0.0535 , 0.1680 , 0.0722 , 0.1788 , 0.1138 , 0.1886 , 0.0467 , 0.1945 , 0.1731 , 0.2010 , 0.0580 , 0.2096 , 0.0392 , 0.2148 , 0.0314 , 0.2201 , 0.0301 , 0.2278 , 0.0798 , 0.2357 , 0.0421 , 0.2450 , 0.0208 , 0.2530 , 0.0484 , 0.2583 , 0.0525 , 0.2636 , 0.0335 , 0.2694 , 0.0311 , 0.2764 , 0.0455 , 0.2817 , 0.0362 , 0.2874 , 0.0252 , 0.2914 , 0.0113 , 0.2954 , 0.0207 , 0.2977 , 0.0120 , 0.3029 , 0.0067 , 0.3054 , 0.0094 , 0.3084 , 0.0135 , 0.3127 , 0.0095 , 0.3157 , 0.0111 , 0.3178 , 0.0036 , 0.3202 , 0.0064 , 0.3221 , 0.0025 , 0.3252 , 0.0016 , 0.3268 , 0.0051 , 0.3297 , 0.0029 , 0.3318 , 0.0038 , 0.3345 , 0.0016 , 0.3366 , 0.0013 , 0.3386 , 0.0009 , 0.3401 , 0.0019 , 0.3416 , 0.0012 , 0.3431 , 0.0015 , 0.3452 , 0.0011 , 0.3471 , 0.0007 , 0.3488 , 0.0003
aR  multitap    ga2mix*kERamp,0.0146 , 0.5281 , 0.0295 , 0.3325 , 0.0450 , 0.3889 , 0.0605 , 0.2096 , 0.0792 , 0.5082 , 0.0881 , 0.1798 , 0.1051 , 0.3287 , 0.1132 , 0.1872 , 0.1243 , 0.1184 , 0.1338 , 0.1134 , 0.1480 , 0.1400 , 0.1594 , 0.2602 , 0.1721 , 0.0610 , 0.1821 , 0.1736 , 0.1908 , 0.0738 , 0.1978 , 0.1547 , 0.2084 , 0.0842 , 0.2187 , 0.0505 , 0.2256 , 0.0906 , 0.2339 , 0.0996 , 0.2428 , 0.0490 , 0.2493 , 0.0186 , 0.2558 , 0.0164 , 0.2596 , 0.0179 , 0.2658 , 0.0298 , 0.2698 , 0.0343 , 0.2750 , 0.0107 , 0.2789 , 0.0417 , 0.2817 , 0.0235 , 0.2879 , 0.0238 , 0.2938 , 0.0202 , 0.2965 , 0.0242 , 0.3015 , 0.0209 , 0.3050 , 0.0139 , 0.3097 , 0.0039 , 0.3137 , 0.0039 , 0.3165 , 0.0096 , 0.3205 , 0.0073 , 0.3231 , 0.0052 , 0.3255 , 0.0069 , 0.3273 , 0.0044 , 0.3298 , 0.0041 , 0.3326 , 0.0026 , 0.3348 , 0.0028 , 0.3372 , 0.0014 , 0.3389 , 0.0023 , 0.3413 , 0.0012 , 0.3428 , 0.0014 , 0.3443 , 0.0006 , 0.3458 , 0.0003 , 0.3474 , 0.0004 , 0.3486 , 0.0005 
elseif kER=4 then   ;large
aL  multitap    ga1mix*kERamp,0.0473 , 0.1344 , 0.0725 , 0.5048 , 0.0997 , 0.2057 , 0.1359 , 0.2231 , 0.1716 , 0.4355 , 0.1963 , 0.1904 , 0.2168 , 0.2274 , 0.2508 , 0.0604 , 0.2660 , 0.1671 , 0.2808 , 0.1725 , 0.3023 , 0.0481 , 0.3154 , 0.1940 , 0.3371 , 0.0651 , 0.3579 , 0.0354 , 0.3718 , 0.0504 , 0.3935 , 0.1609 , 0.4041 , 0.1459 , 0.4166 , 0.1355 , 0.4344 , 0.0747 , 0.4524 , 0.0173 , 0.4602 , 0.0452 , 0.4679 , 0.0643 , 0.4795 , 0.0377 , 0.4897 , 0.0159 , 0.4968 , 0.0433 , 0.5104 , 0.0213 , 0.5170 , 0.0115 , 0.5282 , 0.0102 , 0.5390 , 0.0091 , 0.5451 , 0.0146 , 0.5552 , 0.0371 , 0.5594 , 0.0192 , 0.5667 , 0.0218 , 0.5740 , 0.0176 , 0.5806 , 0.0242 , 0.5871 , 0.0167 , 0.5931 , 0.0184 , 0.6000 , 0.0075 , 0.6063 , 0.0060 , 0.6121 , 0.0068 , 0.6149 , 0.0138 , 0.6183 , 0.0044 , 0.6217 , 0.0035 , 0.6243 , 0.0026 , 0.6274 , 0.0017 , 0.6295 , 0.0098 , 0.6321 , 0.0054 , 0.6352 , 0.0022 , 0.6380 , 0.0011 , 0.6414 , 0.0012 , 0.6432 , 0.0062 , 0.6462 , 0.0024 , 0.6478 , 0.0032 , 0.6506 , 0.0009
aR  multitap    ga2mix*kERamp,0.0271 , 0.5190 , 0.0558 , 0.1827 , 0.0776 , 0.3068 , 0.1186 , 0.2801 , 0.1421 , 0.1526 , 0.1698 , 0.3249 , 0.1918 , 0.1292 , 0.2178 , 0.2828 , 0.2432 , 0.1128 , 0.2743 , 0.1884 , 0.2947 , 0.2023 , 0.3121 , 0.1118 , 0.3338 , 0.0660 , 0.3462 , 0.0931 , 0.3680 , 0.1295 , 0.3889 , 0.1430 , 0.4040 , 0.0413 , 0.4218 , 0.1122 , 0.4381 , 0.1089 , 0.4553 , 0.0691 , 0.4718 , 0.0699 , 0.4832 , 0.0375 , 0.4925 , 0.0119 , 0.5065 , 0.0181 , 0.5180 , 0.0500 , 0.5281 , 0.0228 , 0.5365 , 0.0072 , 0.5458 , 0.0366 , 0.5520 , 0.0065 , 0.5597 , 0.0115 , 0.5644 , 0.0105 , 0.5724 , 0.0063 , 0.5801 , 0.0118 , 0.5836 , 0.0198 , 0.5886 , 0.0172 , 0.5938 , 0.0081 , 0.5987 , 0.0094 , 0.6033 , 0.0029 , 0.6060 , 0.0078 , 0.6096 , 0.0149 , 0.6122 , 0.0102 , 0.6171 , 0.0144 , 0.6204 , 0.0014 , 0.6243 , 0.0038 , 0.6284 , 0.0111 , 0.6309 , 0.0107 , 0.6338 , 0.0036 , 0.6374 , 0.0035 , 0.6401 , 0.0015 , 0.6417 , 0.0052 , 0.6433 , 0.0019 , 0.6461 , 0.0033 , 0.6485 , 0.0007 
elseif kER=5 then   ;huge
aL  multitap    ga1mix*kERamp,0.0588 , 0.6917 , 0.1383 , 0.2512 , 0.2158 , 0.5546 , 0.2586 , 0.2491 , 0.3078 , 0.1830 , 0.3731 , 0.3712 , 0.4214 , 0.1398 , 0.4622 , 0.1870 , 0.5004 , 0.1652 , 0.5365 , 0.2254 , 0.5604 , 0.1423 , 0.5950 , 0.1355 , 0.6233 , 0.1282 , 0.6486 , 0.1312 , 0.6725 , 0.1009 , 0.7063 , 0.0324 , 0.7380 , 0.0968 , 0.7602 , 0.0169 , 0.7854 , 0.0530 , 0.8097 , 0.0342 , 0.8303 , 0.0370 , 0.8404 , 0.0173 , 0.8587 , 0.0281 , 0.8741 , 0.0164 , 0.8825 , 0.0045 , 0.8945 , 0.0181 , 0.9063 , 0.0057 , 0.9136 , 0.0030 , 0.9214 , 0.0065 , 0.9296 , 0.0059 , 0.9373 , 0.0021 , 0.9462 , 0.0087 , 0.9541 , 0.0035 , 0.9605 , 0.0013 , 0.9648 , 0.0043 , 0.9691 , 0.0014 , 0.9746 , 0.0011 , 0.9774 , 0.0032 , 0.9818 , 0.0020 , 0.9853 , 0.0042 , 0.9889 , 0.0030 , 0.9923 , 0.0034 , 0.9941 , 0.0021 , 0.9976 , 0.0009 , 0.9986 , 0.0008
aR  multitap    ga2mix*kERamp,0.0665 , 0.4406 , 0.1335 , 0.6615 , 0.1848 , 0.2284 , 0.2579 , 0.4064 , 0.3293 , 0.1433 , 0.3756 , 0.3222 , 0.4157 , 0.3572 , 0.4686 , 0.3280 , 0.5206 , 0.1134 , 0.5461 , 0.0540 , 0.5867 , 0.0473 , 0.6281 , 0.1018 , 0.6516 , 0.1285 , 0.6709 , 0.0617 , 0.6979 , 0.0360 , 0.7173 , 0.1026 , 0.7481 , 0.0621 , 0.7690 , 0.0585 , 0.7943 , 0.0340 , 0.8072 , 0.0170 , 0.8177 , 0.0092 , 0.8345 , 0.0369 , 0.8511 , 0.0369 , 0.8621 , 0.0251 , 0.8740 , 0.0109 , 0.8849 , 0.0135 , 0.8956 , 0.0118 , 0.9026 , 0.0187 , 0.9110 , 0.0182 , 0.9225 , 0.0034 , 0.9310 , 0.0083 , 0.9354 , 0.0058 , 0.9420 , 0.0040 , 0.9464 , 0.0028 , 0.9549 , 0.0090 , 0.9590 , 0.0076 , 0.9654 , 0.0030 , 0.9691 , 0.0041 , 0.9729 , 0.0009 , 0.9757 , 0.0024 , 0.9787 , 0.0049 , 0.9823 , 0.0040 , 0.9847 , 0.0025 , 0.9898 , 0.0005 , 0.9922 , 0.0022 , 0.9935 , 0.0025 , 0.9964 , 0.0027 , 0.9992 , 0.0007 
elseif kER=6 then   ;long random 
aL  multitap    ga1mix*kERamp,0.0131 , 0.6191 , 0.0518 , 0.4595 , 0.0800 , 0.4688 , 0.2461 , 0.2679 , 0.3826 , 0.1198 , 0.5176 , 0.2924 , 0.6806 , 0.0293 , 0.8211 , 0.0327 , 1.0693 , 0.3318 , 1.2952 , 0.1426 , 1.3079 , 0.1021 , 1.4337 , 0.1293 , 1.4977 , 0.2383 , 1.6702 , 0.0181 , 1.7214 , 0.2042 , 1.8849 , 0.0780 , 2.1279 , 0.0160 , 2.2836 , 0.0061 , 2.4276 , 0.0390 , 2.5733 , 0.1090 , 2.7520 , 0.0047 , 2.8650 , 0.0077 , 3.1026 , 0.0005
aR  multitap    ga2mix*kERamp,0.1591 , 0.4892 , 0.2634 , 0.1430 , 0.3918 , 0.0978 , 0.5004 , 0.0675 , 0.7004 , 0.1285 , 0.7251 , 0.0251 , 0.9368 , 0.4531 , 1.0770 , 0.0022 , 1.1426 , 0.0132 , 1.3189 , 0.1608 , 1.3550 , 0.0512 , 1.4347 , 0.0224 , 1.4739 , 0.1401 , 1.6996 , 0.1680 , 1.9292 , 0.1481 , 2.1435 , 0.2463 , 2.1991 , 0.1748 , 2.3805 , 0.1802 , 2.4796 , 0.0105 , 2.6615 , 0.0049 , 2.8115 , 0.0517 , 2.9687 , 0.0468 , 2.9899 , 0.0095 , 3.1554 , 0.0496 
elseif kER=7 then   ;short backwards
aL  multitap    ga1mix*kERamp,0.0022 , 0.0070 , 0.0040 , 0.0014 , 0.0054 , 0.0120 , 0.0085 , 0.0075 , 0.0106 , 0.0156 , 0.0141 , 0.0089 , 0.0176 , 0.0083 , 0.0200 , 0.0227 , 0.0225 , 0.0189 , 0.0253 , 0.0121 , 0.0284 , 0.0118 , 0.0367 , 0.0193 , 0.0431 , 0.0163 , 0.0477 , 0.0260 , 0.0558 , 0.0259 , 0.0632 , 0.0515 , 0.0694 , 0.0266 , 0.0790 , 0.0279 , 0.0873 , 0.0712 , 0.1075 , 0.1212 , 0.1286 , 0.0938 , 0.1433 , 0.1305 , 0.1591 , 0.0929 , 0.1713 , 0.2410 , 0.1982 , 0.1409 , 0.2144 , 0.3512 , 0.2672 , 0.5038 , 0.3293 , 0.3827
aR  multitap    ga2mix*kERamp,0.0019 , 0.0107 , 0.0030 , 0.0031 , 0.0049 , 0.0068 , 0.0066 , 0.0050 , 0.0098 , 0.0090 , 0.0132 , 0.0080 , 0.0165 , 0.0085 , 0.0196 , 0.0071 , 0.0221 , 0.0143 , 0.0247 , 0.0086 , 0.0316 , 0.0164 , 0.0374 , 0.0160 , 0.0416 , 0.0110 , 0.0511 , 0.0167 , 0.0619 , 0.0191 , 0.0730 , 0.0233 , 0.0887 , 0.0313 , 0.1037 , 0.0484 , 0.1114 , 0.0912 , 0.1219 , 0.0980 , 0.1482 , 0.1220 , 0.1806 , 0.2021 , 0.2057 , 0.2059 , 0.2382 , 0.2379 , 0.2550 , 0.2536 , 0.3112 , 0.6474
elseif kER=8 then   ;long backwards
aL  multitap    ga1mix*kERamp,0.0021 , 0.0008 , 0.0050 , 0.0006 , 0.0065 , 0.0007 , 0.0092 , 0.0014 , 0.0124 , 0.0028 , 0.0145 , 0.0032 , 0.0166 , 0.0015 , 0.0225 , 0.0018 , 0.0294 , 0.0030 , 0.0345 , 0.0077 , 0.0405 , 0.0056 , 0.0454 , 0.0096 , 0.0508 , 0.0088 , 0.0593 , 0.0082 , 0.0643 , 0.0074 , 0.0743 , 0.0182 , 0.0874 , 0.0103 , 0.0986 , 0.0270 , 0.1143 , 0.0135 , 0.1370 , 0.0327 , 0.1633 , 0.0420 , 0.1823 , 0.0708 , 0.2028 , 0.0842 , 0.2258 , 0.0962 , 0.2482 , 0.0513 , 0.2856 , 0.1035 , 0.3132 , 0.1229 , 0.3398 , 0.0721 , 0.3742 , 0.0996 , 0.4199 , 0.1817 , 0.4914 , 0.3000 , 0.5557 , 0.1649 , 0.6181 , 0.4180 , 0.6689 , 0.5216 , 0.7310 , 0.5185
aR  multitap    ga2mix*kERamp,0.0024 , 0.0007 , 0.0053 , 0.0006 , 0.0090 , 0.0034 , 0.0138 , 0.0026 , 0.0196 , 0.0016 , 0.0250 , 0.0080 , 0.0292 , 0.0051 , 0.0346 , 0.0039 , 0.0409 , 0.0089 , 0.0459 , 0.0067 , 0.0589 , 0.0132 , 0.0702 , 0.0192 , 0.0781 , 0.0211 , 0.0964 , 0.0239 , 0.1052 , 0.0201 , 0.1212 , 0.0226 , 0.1428 , 0.0147 , 0.1547 , 0.0418 , 0.1849 , 0.0232 , 0.2110 , 0.0975 , 0.2425 , 0.0620 , 0.2851 , 0.0963 , 0.3366 , 0.1248 , 0.3645 , 0.1321 , 0.4079 , 0.1293 , 0.4433 , 0.1425 , 0.5031 , 0.3787 , 0.5416 , 0.5061 , 0.6336 , 0.2865 , 0.7434 , 0.6477
elseif kER=9 then   ;strange1
aL  multitap    ga1mix*kERamp,0.0137 , 0.2939 , 0.0763 , 0.8381 , 0.2189 , 0.7019 , 0.2531 , 0.2366 , 0.3822 , 0.3756 , 0.4670 , 0.0751 , 0.4821 , 0.0870 , 0.4930 , 0.0794 , 0.5087 , 0.1733 , 0.5633 , 0.0657 , 0.6078 , 0.0218 , 0.6410 , 0.0113 , 0.6473 , 0.0246 , 0.6575 , 0.0513 , 0.6669 , 0.0431 , 0.6693 , 0.0392 , 0.6916 , 0.0050 , 0.6997 , 0.0192 , 0.7091 , 0.0186 , 0.7174 , 0.0105 , 0.7284 , 0.0254 , 0.7366 , 0.0221 , 0.7390 , 0.0112 , 0.7446 , 0.0029 , 0.7470 , 0.0211 , 0.7495 , 0.0006
aR  multitap    ga2mix*kERamp,0.0036 , 0.0052 , 0.0069 , 0.0105 , 0.0096 , 0.0190 , 0.0138 , 0.0235 , 0.0150 , 0.0018 , 0.0231 , 0.0012 , 0.0340 , 0.0022 , 0.0355 , 0.0154 , 0.0415 , 0.0057 , 0.0538 , 0.0237 , 0.0722 , 0.0037 , 0.0839 , 0.0291 , 0.1027 , 0.0500 , 0.1163 , 0.0367 , 0.1375 , 0.0114 , 0.1749 , 0.0156 , 0.2002 , 0.0635 , 0.2215 , 0.0660 , 0.2777 , 0.0517 , 0.3481 , 0.1666 , 0.3871 , 0.2406 , 0.4851 , 0.1022 , 0.5305 , 0.2043 , 0.5910 , 0.4109 , 0.6346 , 0.5573 , 0.7212 , 0.5535 , 0.8981 , 0.5854 
elseif kER=10 then  ;strange2
aL  multitap    ga1mix*kERamp,0.0306 , 0.3604 , 0.2779 , 0.6327 , 0.3687 , 0.2979 , 0.5186 , 0.4202 , 0.6927 , 0.3695 , 0.7185 , 0.2370 , 0.8703 , 0.3283 , 0.9138 , 0.1334 , 0.9610 , 0.1183 , 1.0656 , 0.2089 , 1.1153 , 0.0835 , 1.1933 , 0.0954 , 1.1974 , 0.0609 , 1.2972 , 0.1078 , 1.3243 , 0.0720 , 1.3498 , 0.0840 , 1.4191 , 0.0694 , 1.4479 , 0.0572 , 1.4992 , 0.0449 , 1.5256 , 0.0186 , 1.5704 , 0.0470 , 1.5852 , 0.0202 , 1.6090 , 0.0106 , 1.6165 , 0.0302 , 1.6440 , 0.0204 , 1.6557 , 0.0042 , 1.6582 , 0.0223 , 1.6810 , 0.0054 , 1.6814 , 0.0064 , 1.6943 , 0.0075 , 1.6988 , 0.0032 , 1.7064 , 0.0027 , 1.7073 , 0.0064 , 1.7124 , 0.0091 , 1.7150 , 0.0015 , 1.7218 , 0.0043 , 1.7308 , 0.0116 , 1.7335 , 0.0122 , 1.7355 , 0.0011 , 1.7433 , 0.0154 , 1.7466 , 0.0084 , 1.7487 , 0.0139 , 1.7503 , 0.0123 , 1.7520 , 0.0036 , 1.7561 , 0.0097 , 1.7565 , 0.0041 , 1.7586 , 0.0016 , 1.7657 , 0.0132 , 1.7704 , 0.0038 , 1.7748 , 0.0020 , 1.7777 , 0.0053 , 1.7783 , 0.0056 , 1.7791 , 0.0017 , 1.7818 , 0.0058 , 1.7822 , 0.0089 , 1.7844 , 0.0074 , 1.7863 , 0.0009 , 1.7878 , 0.0016 , 1.7899 , 0.0061 , 1.7919 , 0.0073 , 1.7925 , 0.0025 , 1.7941 , 0.0045 , 1.7956 , 0.0060 , 1.7958 , 0.0088 , 1.7963 , 0.0010 , 1.7965 , 0.0006 , 1.7977 , 0.0078 , 1.7988 , 0.0026
aR  multitap    ga2mix*kERamp,0.0011 , 0.0055 , 0.0022 , 0.0063 , 0.0027 , 0.0089 , 0.0034 , 0.0009 , 0.0049 , 0.0010 , 0.0064 , 0.0005 , 0.0069 , 0.0044 , 0.0091 , 0.0027 , 0.0103 , 0.0099 , 0.0112 , 0.0017 , 0.0131 , 0.0018 , 0.0142 , 0.0008 , 0.0159 , 0.0010 , 0.0188 , 0.0034 , 0.0207 , 0.0055 , 0.0245 , 0.0005 , 0.0262 , 0.0094 , 0.0312 , 0.0057 , 0.0344 , 0.0051 , 0.0402 , 0.0044 , 0.0404 , 0.0102 , 0.0433 , 0.0044 , 0.0435 , 0.0034 , 0.0489 , 0.0087 , 0.0512 , 0.0108 , 0.0605 , 0.0046 , 0.0702 , 0.0010 , 0.0734 , 0.0121 , 0.0839 , 0.0135 , 0.0985 , 0.0151 , 0.1014 , 0.0203 , 0.1041 , 0.0043 , 0.1114 , 0.0150 , 0.1216 , 0.0182 , 0.1293 , 0.0220 , 0.1299 , 0.0169 , 0.1312 , 0.0046 , 0.1453 , 0.0046 , 0.1527 , 0.0062 , 0.1545 , 0.0192 , 0.1578 , 0.0092 , 0.1655 , 0.0053 , 0.1754 , 0.0301 , 0.1967 , 0.0122 , 0.2289 , 0.0233 , 0.2353 , 0.0131 , 0.2632 , 0.0396 , 0.2873 , 0.0171 , 0.3348 , 0.0454 , 0.3872 , 0.0398 , 0.4484 , 0.0244 , 0.4913 , 0.0693 , 0.5424 , 0.0820 , 0.5668 , 0.1112 , 0.6054 , 0.0635 , 0.6669 , 0.1016 , 0.7211 , 0.1217 , 0.7541 , 0.1756 , 0.8759 , 0.1688 , 0.9106 , 0.1932 , 1.0384 , 0.1542 , 1.0732 , 0.1598 , 1.0767 , 0.2409 , 1.0988 , 0.1879 , 1.2422 , 0.3049 , 1.3480 , 0.3001 , 1.4961 , 0.3374 , 1.5886 , 0.2791 , 1.5957 , 0.3366 , 1.8248 , 0.2962 
endif

kin1 chnget "in1"
if kin1=1 then 
a111s=ga1mix+aL
elseif kin1=2 then
a112s=ga1mix+aL
elseif kin1=3 then
a113s=ga1mix+aL
elseif kin1=4 then
a114s=ga1mix+aL
elseif kin1=5 then
a121s=ga1mix+aL
elseif kin1=6 then
a122s=ga1mix+aL
elseif kin1=7 then
a123s=ga1mix+aL
elseif kin1=8 then
a124s=ga1mix+aL
elseif kin1=9 then
a131s=ga1mix+aL
elseif kin1=10 then
a132s=ga1mix+aL
elseif kin1=11 then
a133s=ga1mix+aL
elseif kin1=12 then
a134s=ga1mix+aL
elseif kin1=13 then
a141s=ga1mix+aL
elseif kin1=14 then
a142s=ga1mix+aL
elseif kin1=15 then
a143s=ga1mix+aL
elseif kin1=16 then
a144s=ga1mix+aL
elseif kin1=17 then
a211s=ga1mix+aL
elseif kin1=18 then
a212s=ga1mix+aL
elseif kin1=19 then
a213s=ga1mix+aL
elseif kin1=20 then
a214s=ga1mix+aL
elseif kin1=21 then
a221s=ga1mix+aL
elseif kin1=22 then
a222s=ga1mix+aL
elseif kin1=23 then
a223s=ga1mix+aL
elseif kin1=24 then
a224s=ga1mix+aL
elseif kin1=25 then
a231s=ga1mix+aL
elseif kin1=26 then
a232s=ga1mix+aL
elseif kin1=27 then
a233s=ga1mix+aL
elseif kin1=28 then
a234s=ga1mix+aL
elseif kin1=29 then
a241s=ga1mix+aL
elseif kin1=30 then
a242s=ga1mix+aL
elseif kin1=31 then
a243s=ga1mix+aL
elseif kin1=32 then
a244s=ga1mix+aL
elseif kin1=33 then
a311s=ga1mix+aL
elseif kin1=34 then
a312s=ga1mix+aL
elseif kin1=35 then
a313s=ga1mix+aL
elseif kin1=36 then
a314s=ga1mix+aL
elseif kin1=37 then
a321s=ga1mix+aL
elseif kin1=38 then
a322s=ga1mix+aL
elseif kin1=39 then
a323s=ga1mix+aL
elseif kin1=40 then
a324s=ga1mix+aL
elseif kin1=41 then
a331s=ga1mix+aL
elseif kin1=42 then
a332s=ga1mix+aL
elseif kin1=43 then
a333s=ga1mix+aL
elseif kin1=44 then
a334s=ga1mix+aL
elseif kin1=45 then
a341s=ga1mix+aL
elseif kin1=46 then
a342s=ga1mix+aL
elseif kin1=47 then
a343s=ga1mix+aL
elseif kin1=48 then
a344s=ga1mix+aL
endif

kin2 chnget "in2"
if kin2=1 then 
a111s=ga2mix+aR
elseif kin2=2 then
a112s=ga2mix+aR
elseif kin2=3 then
a113s=ga2mix+aR
elseif kin2=4 then
a114s=ga2mix+aR
elseif kin2=5 then
a121s=ga2mix+aR
elseif kin2=6 then
a122s=ga2mix+aR
elseif kin2=7 then
a123s=ga2mix+aR
elseif kin2=8 then
a124s=ga2mix+aR
elseif kin2=9 then
a131s=ga2mix+aR
elseif kin2=10 then
a132s=ga2mix+aR
elseif kin2=11 then
a133s=ga2mix+aR
elseif kin2=12 then
a134s=ga2mix+aR
elseif kin2=13 then
a141s=ga2mix+aR
elseif kin2=14 then
a142s=ga2mix+aR
elseif kin2=15 then
a143s=ga2mix+aR
elseif kin2=16 then
a144s=ga2mix+aR
elseif kin2=17 then
a211s=ga2mix+aR
elseif kin2=18 then
a212s=ga2mix+aR
elseif kin2=19 then
a213s=ga2mix+aR
elseif kin2=20 then
a214s=ga2mix+aR
elseif kin2=21 then
a221s=ga2mix+aR
elseif kin2=22 then
a222s=ga2mix+aR
elseif kin2=23 then
a223s=ga2mix+aR
elseif kin2=24 then
a224s=ga2mix+aR
elseif kin2=25 then
a231s=ga2mix+aR
elseif kin2=26 then
a232s=ga2mix+aR
elseif kin2=27 then
a233s=ga2mix+aR
elseif kin2=28 then
a234s=ga2mix+aR
elseif kin2=29 then
a241s=ga2mix+aR
elseif kin2=30 then
a242s=ga2mix+aR
elseif kin2=31 then
a243s=ga2mix+aR
elseif kin2=32 then
a244s=ga2mix+aR
elseif kin2=33 then
a311s=ga2mix+aR
elseif kin2=34 then
a312s=ga2mix+aR
elseif kin2=35 then
a313s=ga2mix+aR
elseif kin2=36 then
a314s=ga2mix+aR
elseif kin2=37 then
a321s=ga2mix+aR
elseif kin2=38 then
a322s=ga2mix+aR
elseif kin2=39 then
a323s=ga2mix+aR
elseif kin2=40 then
a324s=ga2mix+aR
elseif kin2=41 then
a331s=ga2mix+aR
elseif kin2=42 then
a332s=ga2mix+aR
elseif kin2=43 then
a333s=ga2mix+aR
elseif kin2=44 then
a334s=ga2mix+aR
elseif kin2=45 then
a341s=ga2mix+aR
elseif kin2=46 then
a342s=ga2mix+aR
elseif kin2=47 then
a343s=ga2mix+aR
elseif kin2=48 then
a344s=ga2mix+aR
endif

kin3 chnget "in3"
if kin3=1 then 
a111s=ga3mix
elseif kin3=2 then
a112s=ga3mix
elseif kin3=3 then
a113s=ga3mix
elseif kin3=4 then
a114s=ga3mix
elseif kin3=5 then
a121s=ga3mix
elseif kin3=6 then
a122s=ga3mix
elseif kin3=7 then
a123s=ga3mix
elseif kin3=8 then
a124s=ga3mix
elseif kin3=9 then
a131s=ga3mix
elseif kin3=10 then
a132s=ga3mix
elseif kin3=11 then
a133s=ga3mix
elseif kin3=12 then
a134s=ga3mix
elseif kin3=13 then
a141s=ga3mix
elseif kin3=14 then
a142s=ga3mix
elseif kin3=15 then
a143s=ga3mix
elseif kin3=16 then
a144s=ga3mix
elseif kin3=17 then
a211s=ga3mix
elseif kin3=18 then
a212s=ga3mix
elseif kin3=19 then
a213s=ga3mix
elseif kin3=20 then
a214s=ga3mix
elseif kin3=21 then
a221s=ga3mix
elseif kin3=22 then
a222s=ga3mix
elseif kin3=23 then
a223s=ga3mix
elseif kin3=24 then
a224s=ga3mix
elseif kin3=25 then
a231s=ga3mix
elseif kin3=26 then
a232s=ga3mix
elseif kin3=27 then
a233s=ga3mix
elseif kin3=28 then
a234s=ga3mix
elseif kin3=29 then
a241s=ga3mix
elseif kin3=30 then
a242s=ga3mix
elseif kin3=31 then
a243s=ga3mix
elseif kin3=32 then
a244s=ga3mix
elseif kin3=33 then
a311s=ga3mix
elseif kin3=34 then
a312s=ga3mix
elseif kin3=35 then
a313s=ga3mix
elseif kin3=36 then
a314s=ga3mix
elseif kin3=37 then
a321s=ga3mix
elseif kin3=38 then
a322s=ga3mix
elseif kin3=39 then
a323s=ga3mix
elseif kin3=40 then
a324s=ga3mix
elseif kin3=41 then
a331s=ga3mix
elseif kin3=42 then
a332s=ga3mix
elseif kin3=43 then
a333s=ga3mix
elseif kin3=44 then
a334s=ga3mix
elseif kin3=45 then
a341s=ga3mix
elseif kin3=46 then
a342s=ga3mix
elseif kin3=47 then
a343s=ga3mix
elseif kin3=48 then
a344s=ga3mix
endif

kin4 chnget "in4"
if kin4=1 then 
a111s=ga4mix
elseif kin4=2 then
a112s=ga4mix
elseif kin4=3 then
a113s=ga4mix
elseif kin4=4 then
a114s=ga4mix
elseif kin4=5 then
a121s=ga4mix
elseif kin4=6 then
a122s=ga4mix
elseif kin4=7 then
a123s=ga4mix
elseif kin4=8 then
a124s=ga4mix
elseif kin4=9 then
a131s=ga4mix
elseif kin4=10 then
a132s=ga4mix
elseif kin4=11 then
a133s=ga4mix
elseif kin4=12 then
a134s=ga4mix
elseif kin4=13 then
a141s=ga4mix
elseif kin4=14 then
a142s=ga4mix
elseif kin4=15 then
a143s=ga4mix
elseif kin4=16 then
a144s=ga4mix
elseif kin4=17 then
a211s=ga4mix
elseif kin4=18 then
a212s=ga4mix
elseif kin4=19 then
a213s=ga4mix
elseif kin4=20 then
a214s=ga4mix
elseif kin4=21 then
a221s=ga4mix
elseif kin4=22 then
a222s=ga4mix
elseif kin4=23 then
a223s=ga4mix
elseif kin4=24 then
a224s=ga4mix
elseif kin4=25 then
a231s=ga4mix
elseif kin4=26 then
a232s=ga4mix
elseif kin4=27 then
a233s=ga4mix
elseif kin4=28 then
a234s=ga4mix
elseif kin4=29 then
a241s=ga4mix
elseif kin4=30 then
a242s=ga4mix
elseif kin4=31 then
a243s=ga4mix
elseif kin4=32 then
a244s=ga4mix
elseif kin4=33 then
a311s=ga4mix
elseif kin4=34 then
a312s=ga4mix
elseif kin4=35 then
a313s=ga4mix
elseif kin4=36 then
a314s=ga4mix
elseif kin4=37 then
a321s=ga4mix
elseif kin4=38 then
a322s=ga4mix
elseif kin4=39 then
a323s=ga4mix
elseif kin4=40 then
a324s=ga4mix
elseif kin4=41 then
a331s=ga4mix
elseif kin4=42 then
a332s=ga4mix
elseif kin4=43 then
a333s=ga4mix
elseif kin4=44 then
a334s=ga4mix
elseif kin4=45 then
a341s=ga4mix
elseif kin4=46 then
a342s=ga4mix
elseif kin4=47 then
a343s=ga4mix
elseif kin4=48 then
a344s=ga4mix
endif

kin5 chnget "in5"
if kin5=1 then 
a111s=ga5mix
elseif kin5=2 then
a112s=ga5mix
elseif kin5=3 then
a113s=ga5mix
elseif kin5=4 then
a114s=ga5mix
elseif kin5=5 then
a121s=ga5mix
elseif kin5=6 then
a122s=ga5mix
elseif kin5=7 then
a123s=ga5mix
elseif kin5=8 then
a124s=ga5mix
elseif kin5=9 then
a131s=ga5mix
elseif kin5=10 then
a132s=ga5mix
elseif kin5=11 then
a133s=ga5mix
elseif kin5=12 then
a134s=ga5mix
elseif kin5=13 then
a141s=ga5mix
elseif kin5=14 then
a142s=ga5mix
elseif kin5=15 then
a143s=ga5mix
elseif kin5=16 then
a144s=ga5mix
elseif kin5=17 then
a211s=ga5mix
elseif kin5=18 then
a212s=ga5mix
elseif kin5=19 then
a213s=ga5mix
elseif kin5=20 then
a214s=ga5mix
elseif kin5=21 then
a221s=ga5mix
elseif kin5=22 then
a222s=ga5mix
elseif kin5=23 then
a223s=ga5mix
elseif kin5=24 then
a224s=ga5mix
elseif kin5=25 then
a231s=ga5mix
elseif kin5=26 then
a232s=ga5mix
elseif kin5=27 then
a233s=ga5mix
elseif kin5=28 then
a234s=ga5mix
elseif kin5=29 then
a241s=ga5mix
elseif kin5=30 then
a242s=ga5mix
elseif kin5=31 then
a243s=ga5mix
elseif kin5=32 then
a244s=ga5mix
elseif kin5=33 then
a311s=ga5mix
elseif kin5=34 then
a312s=ga5mix
elseif kin5=35 then
a313s=ga5mix
elseif kin5=36 then
a314s=ga5mix
elseif kin5=37 then
a321s=ga5mix
elseif kin5=38 then
a322s=ga5mix
elseif kin5=39 then
a323s=ga5mix
elseif kin5=40 then
a324s=ga5mix
elseif kin5=41 then
a331s=ga5mix
elseif kin5=42 then
a332s=ga5mix
elseif kin5=43 then
a333s=ga5mix
elseif kin5=44 then
a334s=ga5mix
elseif kin5=45 then
a341s=ga5mix
elseif kin5=46 then
a342s=ga5mix
elseif kin5=47 then
a343s=ga5mix
elseif kin5=48 then
a344s=ga5mix
endif

kin6 chnget "in6"
if kin6=1 then 
a111s=ga6mix
elseif kin6=2 then
a112s=ga6mix
elseif kin6=3 then
a113s=ga6mix
elseif kin6=4 then
a114s=ga6mix
elseif kin6=5 then
a121s=ga6mix
elseif kin6=6 then
a122s=ga6mix
elseif kin6=7 then
a123s=ga6mix
elseif kin6=8 then
a124s=ga6mix
elseif kin6=9 then
a131s=ga6mix
elseif kin6=10 then
a132s=ga6mix
elseif kin6=11 then
a133s=ga6mix
elseif kin6=12 then
a134s=ga6mix
elseif kin6=13 then
a141s=ga6mix
elseif kin6=14 then
a142s=ga6mix
elseif kin6=15 then
a143s=ga6mix
elseif kin6=16 then
a144s=ga6mix
elseif kin6=17 then
a211s=ga6mix
elseif kin6=18 then
a212s=ga6mix
elseif kin6=19 then
a213s=ga6mix
elseif kin6=20 then
a214s=ga6mix
elseif kin6=21 then
a221s=ga6mix
elseif kin6=22 then
a222s=ga6mix
elseif kin6=23 then
a223s=ga6mix
elseif kin6=24 then
a224s=ga6mix
elseif kin6=25 then
a231s=ga6mix
elseif kin6=26 then
a232s=ga6mix
elseif kin6=27 then
a233s=ga6mix
elseif kin6=28 then
a234s=ga6mix
elseif kin6=29 then
a241s=ga6mix
elseif kin6=30 then
a242s=ga6mix
elseif kin6=31 then
a243s=ga6mix
elseif kin6=32 then
a244s=ga6mix
elseif kin6=33 then
a311s=ga6mix
elseif kin6=34 then
a312s=ga6mix
elseif kin6=35 then
a313s=ga6mix
elseif kin6=36 then
a314s=ga6mix
elseif kin6=37 then
a321s=ga6mix
elseif kin6=38 then
a322s=ga6mix
elseif kin6=39 then
a323s=ga6mix
elseif kin6=40 then
a324s=ga6mix
elseif kin6=41 then
a331s=ga6mix
elseif kin6=42 then
a332s=ga6mix
elseif kin6=43 then
a333s=ga6mix
elseif kin6=44 then
a334s=ga6mix
elseif kin6=45 then
a341s=ga6mix
elseif kin6=46 then
a342s=ga6mix
elseif kin6=47 then
a343s=ga6mix
elseif kin6=48 then
a344s=ga6mix
endif

kin7 chnget "in7"
if kin7=1 then 
a111s=ga7mix
elseif kin7=2 then
a112s=ga7mix
elseif kin7=3 then
a113s=ga7mix
elseif kin7=4 then
a114s=ga7mix
elseif kin7=5 then
a121s=ga7mix
elseif kin7=6 then
a122s=ga7mix
elseif kin7=7 then
a123s=ga7mix
elseif kin7=8 then
a124s=ga7mix
elseif kin7=9 then
a131s=ga7mix
elseif kin7=10 then
a132s=ga7mix
elseif kin7=11 then
a133s=ga7mix
elseif kin7=12 then
a134s=ga7mix
elseif kin7=13 then
a141s=ga7mix
elseif kin7=14 then
a142s=ga7mix
elseif kin7=15 then
a143s=ga7mix
elseif kin7=16 then
a144s=ga7mix
elseif kin7=17 then
a211s=ga7mix
elseif kin7=18 then
a212s=ga7mix
elseif kin7=19 then
a213s=ga7mix
elseif kin7=20 then
a214s=ga7mix
elseif kin7=21 then
a221s=ga7mix
elseif kin7=22 then
a222s=ga7mix
elseif kin7=23 then
a223s=ga7mix
elseif kin7=24 then
a224s=ga7mix
elseif kin7=25 then
a231s=ga7mix
elseif kin7=26 then
a232s=ga7mix
elseif kin7=27 then
a233s=ga7mix
elseif kin7=28 then
a234s=ga7mix
elseif kin7=29 then
a241s=ga7mix
elseif kin7=30 then
a242s=ga7mix
elseif kin7=31 then
a243s=ga7mix
elseif kin7=32 then
a244s=ga7mix
elseif kin7=33 then
a311s=ga7mix
elseif kin7=34 then
a312s=ga7mix
elseif kin7=35 then
a313s=ga7mix
elseif kin7=36 then
a314s=ga7mix
elseif kin7=37 then
a321s=ga7mix
elseif kin7=38 then
a322s=ga7mix
elseif kin7=39 then
a323s=ga7mix
elseif kin7=40 then
a324s=ga7mix
elseif kin7=41 then
a331s=ga7mix
elseif kin7=42 then
a332s=ga7mix
elseif kin7=43 then
a333s=ga7mix
elseif kin7=44 then
a334s=ga7mix
elseif kin7=45 then
a341s=ga7mix
elseif kin7=46 then
a342s=ga7mix
elseif kin7=47 then
a343s=ga7mix
elseif kin7=48 then
a344s=ga7mix
endif

kin8 chnget "in8"
if kin8=1 then 
a111s=ga8mix
elseif kin8=2 then
a112s=ga8mix
elseif kin8=3 then
a113s=ga8mix
elseif kin8=4 then
a114s=ga8mix
elseif kin8=5 then
a121s=ga8mix
elseif kin8=6 then
a122s=ga8mix
elseif kin8=7 then
a123s=ga8mix
elseif kin8=8 then
a124s=ga8mix
elseif kin8=9 then
a131s=ga8mix
elseif kin8=10 then
a132s=ga8mix
elseif kin8=11 then
a133s=ga8mix
elseif kin8=12 then
a134s=ga8mix
elseif kin8=13 then
a141s=ga8mix
elseif kin8=14 then
a142s=ga8mix
elseif kin8=15 then
a143s=ga8mix
elseif kin8=16 then
a144s=ga8mix
elseif kin8=17 then
a211s=ga8mix
elseif kin8=18 then
a212s=ga8mix
elseif kin8=19 then
a213s=ga8mix
elseif kin8=20 then
a214s=ga8mix
elseif kin8=21 then
a221s=ga8mix
elseif kin8=22 then
a222s=ga8mix
elseif kin8=23 then
a223s=ga8mix
elseif kin8=24 then
a224s=ga8mix
elseif kin8=25 then
a231s=ga8mix
elseif kin8=26 then
a232s=ga8mix
elseif kin8=27 then
a233s=ga8mix
elseif kin8=28 then
a234s=ga8mix
elseif kin8=29 then
a241s=ga8mix
elseif kin8=30 then
a242s=ga8mix
elseif kin8=31 then
a243s=ga8mix
elseif kin8=32 then
a244s=ga8mix
elseif kin8=33 then
a311s=ga8mix
elseif kin8=34 then
a312s=ga8mix
elseif kin8=35 then
a313s=ga8mix
elseif kin8=36 then
a314s=ga8mix
elseif kin8=37 then
a321s=ga8mix
elseif kin8=38 then
a322s=ga8mix
elseif kin8=39 then
a323s=ga8mix
elseif kin8=40 then
a324s=ga8mix
elseif kin8=41 then
a331s=ga8mix
elseif kin8=42 then
a332s=ga8mix
elseif kin8=43 then
a333s=ga8mix
elseif kin8=44 then
a334s=ga8mix
elseif kin8=45 then
a341s=ga8mix
elseif kin8=46 then
a342s=ga8mix
elseif kin8=47 then
a343s=ga8mix
elseif kin8=48 then
a344s=ga8mix
endif

a111a,a111b,a111c,a111d,a111e,a111f,a111o meshEQ a121c,a112d,-a111c,-a111d,a211f,-a111f,a111s,adel111,kFB
a112a,a112b,a112c,a112d,a112e,a112f,a112o meshEQ a122c,a113d,-a112c,a111b,a212f,-a112f,a112s,adel112,kFB
a113a,a113b,a113c,a113d,a113e,a113f,a113o meshEQ a123c,a114d,-a113c,a112b,a213f,-a113f,a113s,adel113,kFB
a114a,a114b,a114c,a114d,a114e,a114f,a114o meshEQ a124c,-a114b,-a114c,a113b,a214f,-a114f,a114s,adel114,kFB

a121a,a121b,a121c,a121d,a121e,a121f,a121o meshEQ a131c,a122d,a111a,-a121d,a221f,-a121f,a121s,adel121,kFB
a122a,a122b,a122c,a122d,a122e,a122f,a122o meshEQ a132c,a123d,a112a,a121b,a222f,-a122f,a122s,adel122,kFB
a123a,a123b,a123c,a123d,a123e,a123f,a123o meshEQ a133c,a124d,a113a,a122b,a223f,-a123f,a123s,adel123,kFB
a124a,a124b,a124c,a124d,a124e,a124f,a124o meshEQ a134c,-a124b,a114a,a123b,a224f,-a124f,a124s,adel124,kFB

a131a,a131b,a131c,a131d,a131e,a131f,a131o meshEQ a141c,a132d,a121a,-a131d,a231f,-a131f,a131s,adel131,kFB
a132a,a132b,a132c,a132d,a132e,a132f,a132o meshEQ a142c,a133d,a122a,a131b,a232f,-a132f,a132s,adel132,kFB
a133a,a133b,a133c,a133d,a133e,a133f,a133o meshEQ a143c,a134d,a123a,a132b,a233f,-a133f,a133s,adel133,kFB
a134a,a134b,a134c,a134d,a134e,a134f,a134o meshEQ a144c,-a134b,a124a,a133b,a234f,-a134f,a134s,adel134,kFB

a141a,a141b,a141c,a141d,a141e,a141f,a141o meshEQ -a141a,a142d,a131a,-a141d,a241f,-a141f,a141s,adel141,kFB
a142a,a142b,a142c,a142d,a142e,a142f,a142o meshEQ -a142a,a143d,a132a,a141b,a242f,-a142f,a142s,adel142,kFB
a143a,a143b,a143c,a143d,a143e,a143f,a143o meshEQ -a143a,a144d,a133a,a142b,a243f,-a143f,a143s,adel143,kFB
a144a,a144b,a144c,a144d,a144e,a144f,a144o meshEQ -a144a,-a144b,a134a,a143b,a244f,-a144f,a144s,adel144,kFB


a211a,a211b,a211c,a211d,a211e,a211f,a211o meshEQ a221c,a212d,-a211c,-a211d,a311f,a111e,a211s,adel211,kFB
a212a,a212b,a212c,a212d,a212e,a212f,a212o meshEQ a222c,a213d,-a212c,a211b,a312f,a112e,a212s,adel212,kFB
a213a,a213b,a213c,a213d,a213e,a213f,a213o meshEQ a223c,a214d,-a213c,a212b,a313f,a113e,a213s,adel213,kFB
a214a,a214b,a214c,a214d,a214e,a214f,a214o meshEQ a224c,-a214b,-a214c,a213b,a314f,a114e,a214s,adel214,kFB

a221a,a221b,a221c,a221d,a221e,a221f,a221o meshEQ a231c,a222d,a211a,-a221d,a321f,a121e,a221s,adel221,kFB
a222a,a222b,a222c,a222d,a222e,a222f,a222o meshEQ a232c,a223d,a212a,a221b,a322f,a122e,a222s,adel222,kFB
a223a,a223b,a223c,a223d,a223e,a223f,a223o meshEQ a233c,a224d,a213a,a222b,a323f,a123e,a223s,adel223,kFB
a224a,a224b,a224c,a224d,a224e,a224f,a224o meshEQ a234c,-a224b,a214a,a223b,a324f,a124e,a224s,adel224,kFB

a231a,a231b,a231c,a231d,a231e,a231f,a231o meshEQ a241c,a232d,a221a,-a231d,a331f,a131e,a231s,adel231,kFB
a232a,a232b,a232c,a232d,a232e,a232f,a232o meshEQ a242c,a233d,a222a,a231b,a332f,a132e,a232s,adel232,kFB
a233a,a233b,a233c,a233d,a233e,a233f,a233o meshEQ a243c,a234d,a223a,a232b,a333f,a133e,a233s,adel233,kFB
a234a,a234b,a234c,a234d,a234e,a234f,a234o meshEQ a244c,-a234b,a224a,a233b,a334f,a134e,a234s,adel234,kFB

a241a,a241b,a241c,a241d,a241e,a241f,a241o meshEQ -a241a,a242d,a231a,-a241d,a341f,a141e,a241s,adel241,kFB
a242a,a242b,a242c,a242d,a242e,a242f,a242o meshEQ -a242a,a243d,a232a,a241b,a342f,a142e,a242s,adel242,kFB
a243a,a243b,a243c,a243d,a243e,a243f,a243o meshEQ -a243a,a244d,a233a,a242b,a343f,a143e,a243s,adel243,kFB
a244a,a244b,a244c,a244d,a244e,a244f,a244o meshEQ -a244a,-a244b,a234a,a243b,a344f,a144e,a244s,adel244,kFB


a311a,a311b,a311c,a311d,a311e,a311f,a311o meshEQ a321c,a312d,-a311c,-a311d,-a311e,a211e,a311s,adel311,kFB
a312a,a312b,a312c,a312d,a312e,a312f,a312o meshEQ a322c,a313d,-a312c,a311b,-a312e,a212e,a312s,adel312,kFB
a313a,a313b,a313c,a313d,a313e,a313f,a313o meshEQ a323c,a314d,-a313c,a312b,-a313e,a213e,a313s,adel313,kFB
a314a,a314b,a314c,a314d,a314e,a314f,a314o meshEQ a324c,-a314b,-a314c,a313b,-a314e,a214e,a314s,adel314,kFB

a321a,a321b,a321c,a321d,a321e,a321f,a321o meshEQ a331c,a322d,a311a,-a321d,-a321e,a221e,a321s,adel321,kFB
a322a,a322b,a322c,a322d,a322e,a322f,a322o meshEQ a332c,a323d,a312a,a321b,-a322e,a222e,a322s,adel322,kFB
a323a,a323b,a323c,a323d,a323e,a323f,a323o meshEQ a333c,a324d,a313a,a322b,-a323e,a223e,a323s,adel323,kFB
a324a,a324b,a324c,a324d,a324e,a324f,a324o meshEQ a334c,-a324b,a314a,a323b,-a324e,a224e,a324s,adel324,kFB

a331a,a331b,a331c,a331d,a331e,a331f,a331o meshEQ a341c,a332d,a321a,-a331d,-a331e,a231e,a331s,adel331,kFB
a332a,a332b,a332c,a332d,a332e,a332f,a332o meshEQ a342c,a333d,a322a,a331b,-a332e,a232e,a332s,adel332,kFB
a333a,a333b,a333c,a333d,a333e,a333f,a333o meshEQ a343c,a334d,a323a,a332b,-a333e,a233e,a333s,adel333,kFB
a334a,a334b,a334c,a334d,a334e,a334f,a334o meshEQ a344c,-a334b,a324a,a333b,-a334e,a234e,a334s,adel334,kFB

a341a,a341b,a341c,a341d,a341e,a341f,a341o meshEQ -a341a,a342d,a331a,-a341d,-a341e,a241e,a341s,adel341,kFB
a342a,a342b,a342c,a342d,a342e,a342f,a342o meshEQ -a342a,a343d,a332a,a341b,-a342e,a242e,a342s,adel342,kFB
a343a,a343b,a343c,a343d,a343e,a343f,a343o meshEQ -a343a,a344d,a333a,a342b,-a343e,a243e,a343s,adel343,kFB
a344a,a344b,a344c,a344d,a344e,a344f,a344o meshEQ -a344a,-a344b,a334a,a343b,-a344e,a244e,a344s,adel344,kFB

kout1 chnget "out1"
if kout1=1 then 
a1out=a111o
elseif kout1=2 then
a1out=a112o
elseif kout1=3 then
a1out=a113o
elseif kout1=4 then
a1out=a114o
elseif kout1=5 then
a1out=a121o
elseif kout1=6 then
a1out=a122o
elseif kout1=7 then
a1out=a123o
elseif kout1=8 then
a1out=a124o
elseif kout1=9 then
a1out=a131o
elseif kout1=10 then
a1out=a132o
elseif kout1=11 then
a1out=a133o
elseif kout1=12 then
a1out=a134o
elseif kout1=13 then
a1out=a141o
elseif kout1=14 then
a1out=a142o
elseif kout1=15 then
a1out=a143o
elseif kout1=16 then
a1out=a144o
elseif kout1=17 then
a1out=a211o
elseif kout1=18 then
a1out=a212o
elseif kout1=19 then
a1out=a213o
elseif kout1=20 then
a1out=a214o
elseif kout1=21 then
a1out=a221o
elseif kout1=22 then
a1out=a222o
elseif kout1=23 then
a1out=a223o
elseif kout1=24 then
a1out=a224o
elseif kout1=25 then
a1out=a231o
elseif kout1=26 then
a1out=a232o
elseif kout1=27 then
a1out=a233o
elseif kout1=28 then
a1out=a234o
elseif kout1=29 then
a1out=a241o
elseif kout1=30 then
a1out=a242o
elseif kout1=31 then
a1out=a243o
elseif kout1=32 then
a1out=a244o
elseif kout1=33 then
a1out=a311o
elseif kout1=34 then
a1out=a312o
elseif kout1=35 then
a1out=a313o
elseif kout1=36 then
a1out=a314o
elseif kout1=37 then
a1out=a321o
elseif kout1=38 then
a1out=a322o
elseif kout1=39 then
a1out=a323o
elseif kout1=40 then
a1out=a324o
elseif kout1=41 then
a1out=a331o
elseif kout1=42 then
a1out=a332o
elseif kout1=43 then
a1out=a333o
elseif kout1=44 then
a1out=a334o
elseif kout1=45 then
a1out=a341o
elseif kout1=46 then
a1out=a342o
elseif kout1=47 then
a1out=a343o
elseif kout1=48 then
a1out=a344o
endif

kout2 chnget "out2"
if kout2=1 then 
a2out=a111o
elseif kout2=2 then
a2out=a112o
elseif kout2=3 then
a2out=a113o
elseif kout2=4 then
a2out=a114o
elseif kout2=5 then
a2out=a121o
elseif kout2=6 then
a2out=a122o
elseif kout2=7 then
a2out=a123o
elseif kout2=8 then
a2out=a124o
elseif kout2=9 then
a2out=a131o
elseif kout2=10 then
a2out=a132o
elseif kout2=11 then
a2out=a133o
elseif kout2=12 then
a2out=a134o
elseif kout2=13 then
a2out=a141o
elseif kout2=14 then
a2out=a142o
elseif kout2=15 then
a2out=a143o
elseif kout2=16 then
a2out=a144o
elseif kout2=17 then
a2out=a211o
elseif kout2=18 then
a2out=a212o
elseif kout2=19 then
a2out=a213o
elseif kout2=20 then
a2out=a214o
elseif kout2=21 then
a2out=a221o
elseif kout2=22 then
a2out=a222o
elseif kout2=23 then
a2out=a223o
elseif kout2=24 then
a2out=a224o
elseif kout2=25 then
a2out=a231o
elseif kout2=26 then
a2out=a232o
elseif kout2=27 then
a2out=a233o
elseif kout2=28 then
a2out=a234o
elseif kout2=29 then
a2out=a241o
elseif kout2=30 then
a2out=a242o
elseif kout2=31 then
a2out=a243o
elseif kout2=32 then
a2out=a244o
elseif kout2=33 then
a2out=a311o
elseif kout2=34 then
a2out=a312o
elseif kout2=35 then
a2out=a313o
elseif kout2=36 then
a2out=a314o
elseif kout2=37 then
a2out=a321o
elseif kout2=38 then
a2out=a322o
elseif kout2=39 then
a2out=a323o
elseif kout2=40 then
a2out=a324o
elseif kout2=41 then
a2out=a331o
elseif kout2=42 then
a2out=a332o
elseif kout2=43 then
a2out=a333o
elseif kout2=44 then
a2out=a334o
elseif kout2=45 then
a2out=a341o
elseif kout2=46 then
a2out=a342o
elseif kout2=47 then
a2out=a343o
elseif kout2=48 then
a2out=a344o
endif

kout3 chnget "out3"
if kout3=1 then 
a3out=a111o
elseif kout3=2 then
a3out=a112o
elseif kout3=3 then
a3out=a113o
elseif kout3=4 then
a3out=a114o
elseif kout3=5 then
a3out=a121o
elseif kout3=6 then
a3out=a122o
elseif kout3=7 then
a3out=a123o
elseif kout3=8 then
a3out=a124o
elseif kout3=9 then
a3out=a131o
elseif kout3=10 then
a3out=a132o
elseif kout3=11 then
a3out=a133o
elseif kout3=12 then
a3out=a134o
elseif kout3=13 then
a3out=a141o
elseif kout3=14 then
a3out=a142o
elseif kout3=15 then
a3out=a143o
elseif kout3=16 then
a3out=a144o
elseif kout3=17 then
a3out=a211o
elseif kout3=18 then
a3out=a212o
elseif kout3=19 then
a3out=a213o
elseif kout3=20 then
a3out=a214o
elseif kout3=21 then
a3out=a221o
elseif kout3=22 then
a3out=a222o
elseif kout3=23 then
a3out=a223o
elseif kout3=24 then
a3out=a224o
elseif kout3=25 then
a3out=a231o
elseif kout3=26 then
a3out=a232o
elseif kout3=27 then
a3out=a233o
elseif kout3=28 then
a3out=a234o
elseif kout3=29 then
a3out=a241o
elseif kout3=30 then
a3out=a242o
elseif kout3=31 then
a3out=a243o
elseif kout3=32 then
a3out=a244o
elseif kout3=33 then
a3out=a311o
elseif kout3=34 then
a3out=a312o
elseif kout3=35 then
a3out=a313o
elseif kout3=36 then
a3out=a314o
elseif kout3=37 then
a3out=a321o
elseif kout3=38 then
a3out=a322o
elseif kout3=39 then
a3out=a323o
elseif kout3=40 then
a3out=a324o
elseif kout3=41 then
a3out=a331o
elseif kout3=42 then
a3out=a332o
elseif kout3=43 then
a3out=a333o
elseif kout3=44 then
a3out=a334o
elseif kout3=45 then
a3out=a341o
elseif kout3=46 then
a3out=a342o
elseif kout3=47 then
a3out=a343o
elseif kout3=48 then
a3out=a344o
endif

kout4 chnget "out4"
if kout4=1 then 
a4out=a111o
elseif kout4=2 then
a4out=a112o
elseif kout4=3 then
a4out=a113o
elseif kout4=4 then
a4out=a114o
elseif kout4=5 then
a4out=a121o
elseif kout4=6 then
a4out=a122o
elseif kout4=7 then
a4out=a123o
elseif kout4=8 then
a4out=a124o
elseif kout4=9 then
a4out=a131o
elseif kout4=10 then
a4out=a132o
elseif kout4=11 then
a4out=a133o
elseif kout4=12 then
a4out=a134o
elseif kout4=13 then
a4out=a141o
elseif kout4=14 then
a4out=a142o
elseif kout4=15 then
a4out=a143o
elseif kout4=16 then
a4out=a144o
elseif kout4=17 then
a4out=a211o
elseif kout4=18 then
a4out=a212o
elseif kout4=19 then
a4out=a213o
elseif kout4=20 then
a4out=a214o
elseif kout4=21 then
a4out=a221o
elseif kout4=22 then
a4out=a222o
elseif kout4=23 then
a4out=a223o
elseif kout4=24 then
a4out=a224o
elseif kout4=25 then
a4out=a231o
elseif kout4=26 then
a4out=a232o
elseif kout4=27 then
a4out=a233o
elseif kout4=28 then
a4out=a234o
elseif kout4=29 then
a4out=a241o
elseif kout4=30 then
a4out=a242o
elseif kout4=31 then
a4out=a243o
elseif kout4=32 then
a4out=a244o
elseif kout4=33 then
a4out=a311o
elseif kout4=34 then
a4out=a312o
elseif kout4=35 then
a4out=a313o
elseif kout4=36 then
a4out=a314o
elseif kout4=37 then
a4out=a321o
elseif kout4=38 then
a4out=a322o
elseif kout4=39 then
a4out=a323o
elseif kout4=40 then
a4out=a324o
elseif kout4=41 then
a4out=a331o
elseif kout4=42 then
a4out=a332o
elseif kout4=43 then
a4out=a333o
elseif kout4=44 then
a4out=a334o
elseif kout4=45 then
a4out=a341o
elseif kout4=46 then
a4out=a342o
elseif kout4=47 then
a4out=a343o
elseif kout4=48 then
a4out=a344o
endif

kout5 chnget "out5"
if kout5=1 then 
a5out=a111o
elseif kout5=2 then
a5out=a112o
elseif kout5=3 then
a5out=a113o
elseif kout5=4 then
a5out=a114o
elseif kout5=5 then
a5out=a121o
elseif kout5=6 then
a5out=a122o
elseif kout5=7 then
a5out=a123o
elseif kout5=8 then
a5out=a124o
elseif kout5=9 then
a5out=a131o
elseif kout5=10 then
a5out=a132o
elseif kout5=11 then
a5out=a133o
elseif kout5=12 then
a5out=a134o
elseif kout5=13 then
a5out=a141o
elseif kout5=14 then
a5out=a142o
elseif kout5=15 then
a5out=a143o
elseif kout5=16 then
a5out=a144o
elseif kout5=17 then
a5out=a211o
elseif kout5=18 then
a5out=a212o
elseif kout5=19 then
a5out=a213o
elseif kout5=20 then
a5out=a214o
elseif kout5=21 then
a5out=a221o
elseif kout5=22 then
a5out=a222o
elseif kout5=23 then
a5out=a223o
elseif kout5=24 then
a5out=a224o
elseif kout5=25 then
a5out=a231o
elseif kout5=26 then
a5out=a232o
elseif kout5=27 then
a5out=a233o
elseif kout5=28 then
a5out=a234o
elseif kout5=29 then
a5out=a241o
elseif kout5=30 then
a5out=a242o
elseif kout5=31 then
a5out=a243o
elseif kout5=32 then
a5out=a244o
elseif kout5=33 then
a5out=a311o
elseif kout5=34 then
a5out=a312o
elseif kout5=35 then
a5out=a313o
elseif kout5=36 then
a5out=a314o
elseif kout5=37 then
a5out=a321o
elseif kout5=38 then
a5out=a322o
elseif kout5=39 then
a5out=a323o
elseif kout5=40 then
a5out=a324o
elseif kout5=41 then
a5out=a331o
elseif kout5=42 then
a5out=a332o
elseif kout5=43 then
a5out=a333o
elseif kout5=44 then
a5out=a334o
elseif kout5=45 then
a5out=a341o
elseif kout5=46 then
a5out=a342o
elseif kout5=47 then
a5out=a343o
elseif kout5=48 then
a5out=a344o
endif

kout6 chnget "out6"
if kout6=1 then 
a6out=a111o
elseif kout6=2 then
a6out=a112o
elseif kout6=3 then
a6out=a113o
elseif kout6=4 then
a6out=a114o
elseif kout6=5 then
a6out=a121o
elseif kout6=6 then
a6out=a122o
elseif kout6=7 then
a6out=a123o
elseif kout6=8 then
a6out=a124o
elseif kout6=9 then
a6out=a131o
elseif kout6=10 then
a6out=a132o
elseif kout6=11 then
a6out=a133o
elseif kout6=12 then
a6out=a134o
elseif kout6=13 then
a6out=a141o
elseif kout6=14 then
a6out=a142o
elseif kout6=15 then
a6out=a143o
elseif kout6=16 then
a6out=a144o
elseif kout6=17 then
a6out=a211o
elseif kout6=18 then
a6out=a212o
elseif kout6=19 then
a6out=a213o
elseif kout6=20 then
a6out=a214o
elseif kout6=21 then
a6out=a221o
elseif kout6=22 then
a6out=a222o
elseif kout6=23 then
a6out=a223o
elseif kout6=24 then
a6out=a224o
elseif kout6=25 then
a6out=a231o
elseif kout6=26 then
a6out=a232o
elseif kout6=27 then
a6out=a233o
elseif kout6=28 then
a6out=a234o
elseif kout6=29 then
a6out=a241o
elseif kout6=30 then
a6out=a242o
elseif kout6=31 then
a6out=a243o
elseif kout6=32 then
a6out=a244o
elseif kout6=33 then
a6out=a311o
elseif kout6=34 then
a6out=a312o
elseif kout6=35 then
a6out=a313o
elseif kout6=36 then
a6out=a314o
elseif kout6=37 then
a6out=a321o
elseif kout6=38 then
a6out=a322o
elseif kout6=39 then
a6out=a323o
elseif kout6=40 then
a6out=a324o
elseif kout6=41 then
a6out=a331o
elseif kout6=42 then
a6out=a332o
elseif kout6=43 then
a6out=a333o
elseif kout6=44 then
a6out=a334o
elseif kout6=45 then
a6out=a341o
elseif kout6=46 then
a6out=a342o
elseif kout6=47 then
a6out=a343o
elseif kout6=48 then
a6out=a344o
endif

kout7 chnget "out7"
if kout7=1 then 
a7out=a111o
elseif kout7=2 then
a7out=a112o
elseif kout7=3 then
a7out=a113o
elseif kout7=4 then
a7out=a114o
elseif kout7=5 then
a7out=a121o
elseif kout7=6 then
a7out=a122o
elseif kout7=7 then
a7out=a123o
elseif kout7=8 then
a7out=a124o
elseif kout7=9 then
a7out=a131o
elseif kout7=10 then
a7out=a132o
elseif kout7=11 then
a7out=a133o
elseif kout7=12 then
a7out=a134o
elseif kout7=13 then
a7out=a141o
elseif kout7=14 then
a7out=a142o
elseif kout7=15 then
a7out=a143o
elseif kout7=16 then
a7out=a144o
elseif kout7=17 then
a7out=a211o
elseif kout7=18 then
a7out=a212o
elseif kout7=19 then
a7out=a213o
elseif kout7=20 then
a7out=a214o
elseif kout7=21 then
a7out=a221o
elseif kout7=22 then
a7out=a222o
elseif kout7=23 then
a7out=a223o
elseif kout7=24 then
a7out=a224o
elseif kout7=25 then
a7out=a231o
elseif kout7=26 then
a7out=a232o
elseif kout7=27 then
a7out=a233o
elseif kout7=28 then
a7out=a234o
elseif kout7=29 then
a7out=a241o
elseif kout7=30 then
a7out=a242o
elseif kout7=31 then
a7out=a243o
elseif kout7=32 then
a7out=a244o
elseif kout7=33 then
a7out=a311o
elseif kout7=34 then
a7out=a312o
elseif kout7=35 then
a7out=a313o
elseif kout7=36 then
a7out=a314o
elseif kout7=37 then
a7out=a321o
elseif kout7=38 then
a7out=a322o
elseif kout7=39 then
a7out=a323o
elseif kout7=40 then
a7out=a324o
elseif kout7=41 then
a7out=a331o
elseif kout7=42 then
a7out=a332o
elseif kout7=43 then
a7out=a333o
elseif kout7=44 then
a7out=a334o
elseif kout7=45 then
a7out=a341o
elseif kout7=46 then
a7out=a342o
elseif kout7=47 then
a7out=a343o
elseif kout7=48 then
a7out=a344o
endif

kout8 chnget "out8"
if kout8=1 then 
a8out=a111o
elseif kout8=2 then
a8out=a112o
elseif kout8=3 then
a8out=a113o
elseif kout8=4 then
a8out=a114o
elseif kout8=5 then
a8out=a121o
elseif kout8=6 then
a8out=a122o
elseif kout8=7 then
a8out=a123o
elseif kout8=8 then
a8out=a124o
elseif kout8=9 then
a8out=a131o
elseif kout8=10 then
a8out=a132o
elseif kout8=11 then
a8out=a133o
elseif kout8=12 then
a8out=a134o
elseif kout8=13 then
a8out=a141o
elseif kout8=14 then
a8out=a142o
elseif kout8=15 then
a8out=a143o
elseif kout8=16 then
a8out=a144o
elseif kout8=17 then
a8out=a211o
elseif kout8=18 then
a8out=a212o
elseif kout8=19 then
a8out=a213o
elseif kout8=20 then
a8out=a214o
elseif kout8=21 then
a8out=a221o
elseif kout8=22 then
a8out=a222o
elseif kout8=23 then
a8out=a223o
elseif kout8=24 then
a8out=a224o
elseif kout8=25 then
a8out=a231o
elseif kout8=26 then
a8out=a232o
elseif kout8=27 then
a8out=a233o
elseif kout8=28 then
a8out=a234o
elseif kout8=29 then
a8out=a241o
elseif kout8=30 then
a8out=a242o
elseif kout8=31 then
a8out=a243o
elseif kout8=32 then
a8out=a244o
elseif kout8=33 then
a8out=a311o
elseif kout8=34 then
a8out=a312o
elseif kout8=35 then
a8out=a313o
elseif kout8=36 then
a8out=a314o
elseif kout8=37 then
a8out=a321o
elseif kout8=38 then
a8out=a322o
elseif kout8=39 then
a8out=a323o
elseif kout8=40 then
a8out=a324o
elseif kout8=41 then
a8out=a331o
elseif kout8=42 then
a8out=a332o
elseif kout8=43 then
a8out=a333o
elseif kout8=44 then
a8out=a334o
elseif kout8=45 then
a8out=a341o
elseif kout8=46 then
a8out=a342o
elseif kout8=47 then
a8out=a343o
elseif kout8=48 then
a8out=a344o
endif

garev1=dcblock2(a1out)
garev2=dcblock2(a2out)
garev3=dcblock2(a3out)
garev4=dcblock2(a4out)
garev5=dcblock2(a5out)
garev6=dcblock2(a6out)
garev7=dcblock2(a7out)
garev8=dcblock2(a8out)
endin

instr 60	; record file
irecch chnget "recch"
ibit chnget "bit"
 print	p1
 if gkplay==1 then
  chnset	k(0),"record"
  turnoff
 endif
 gkFileRecorded		init	1
 itim     date
 Stim     dates     itim
 itim     date
 Stim     dates     itim
 Syear    strsub    Stim, 20, 24
 Smonth   strsub    Stim, 4, 7
 Sday     strsub    Stim, 8, 10
 iday     strtod    Sday
 Shor     strsub    Stim, 11, 13
 Smin     strsub    Stim, 14, 16
 Ssec     strsub    Stim, 17, 19
 Sfilnam  sprintf  "%s_%s_%02d_%s_%s_%s.wav", Syear, Smonth, iday, Shor,Smin, Ssec
 gSname   sprintf "MVerb3D_%s", Sfilnam
 if gkrecord==1 then			; record
  if ibit=1 then
   imode=4
  elseif ibit=2 then
   imode=8
  elseif ibit=3 then
   imode=5
  endif
  if irecch=1 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource)
  elseif irecch=2 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource) 
  elseif irecch=3 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource)
  elseif irecch=4 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource)
  elseif irecch=5 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource),(garev5*gkFX)+(ga5mix*gksource)
  elseif irecch=6 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource),(garev5*gkFX)+(ga5mix*gksource),(garev6*gkFX)+(ga6mix*gksource)
  elseif irecch=7 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource),(garev5*gkFX)+(ga5mix*gksource),(garev6*gkFX)+(ga6mix*gksource),(garev7*gkFX)+(ga7mix*gksource)
  elseif irecch=8 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource),(garev5*gkFX)+(ga5mix*gksource),(garev6*gkFX)+(ga6mix*gksource),(garev7*gkFX)+(ga7mix*gksource),(garev8*gkFX)+(ga8mix*gksource)
  endif
 endif
 gkRecordingActiveFlag	=	1 - release()
endin

instr	61	; play file
 if gkplay==0 then
  turnoff
 endif 
 ichnl filenchnls gSname
 if ichnl==1 then
    a1	diskin2	gSname,1
 elseif ichnl==2 then
    a1,a2	diskin2	gSname,1
 elseif ichnl==3 then
    a1,a2,a3	diskin2	gSname,1
 elseif ichnl==4 then
   a1,a2,a3,a4	diskin2	gSname,1
 elseif ichnl==5 then
   a1,a2,a3,a4,a5	diskin2	gSname,1
 elseif ichnl==6 then
   a1,a2,a3,a4,a5,a6	diskin2	gSname,1
 elseif ichnl==7 then
   a1,a2,a3,a4,a5,a6,a7	diskin2	gSname,1
 elseif ichnl==8 then
   a1,a2,a3,a4,a5,a6,a7,a8	diskin2	gSname,1
 endif
 	outo	a1,a2,a3,a4,a5,a6,a7,a8
 iFileLen	filelen	gSname
 p3	=	iFileLen
 xtratim	0.1 
 krelease	release
 	chnset	1-krelease,"play"
endin

instr 100   ;instrument to monitor MIDI controller numbers, creates global MIDI outputs that are evaluated by instr 110-300         
            ;also controls popup fpr latched LowPass
gkstatus,gkchan,gkdata1,gkdata2 midiin
if changed(gkstatus)==1 then  
    if gkstatus==176 then
    chnset gkdata1,"CtrlNum" ;displays current controller number in GUI
    endif
endif
endin

instr 101 ;MIDI mapping (input amp, size factor, FB, and Early Reflection amp
kmapliveamp chnget "mapliveamp"
kmapliveampX chnget "mapliveampX"
kmapDFact chnget "mapDFact"
kmapDFactX chnget "mapDFactX"
kmapFB chnget "mapFB"
kmapFBX chnget "mapFBX"
kmapERamp chnget "mapERamp"
kmapERampX chnget "mapERampX"
kmaprmax chnget "maprmax"
kmaprmaxX chnget "maprmaxX"
kmaprrate chnget "maprrate"
kmaprrateX chnget "maprrateX"
kmaprratedev chnget "maprratedev"
kmaprratedevX chnget "maprratedevX"
kmapmix chnget "mapmix"
kmapmixX chnget "mapmixX"
kmapport chnget "mapport"
kmapportX chnget "mapportX"
kmapsfspeed chnget "mapsfspeed"
kmapsfspeedX chnget "mapsfspeedX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapliveamp==1 then
      turnoff2 102,2,0
      event "i",102,0,999999
    elseif kmapDFact==1 then
      turnoff2 103,2,0
      event "i",103,0,999999
    elseif kmapFB==1 then
      turnoff2 104,2,0
      event "i",104,0,999999
    elseif kmapERamp==1 then
      turnoff2 105,2,0
      event "i",105,0,999999
    elseif kmaprmax==1 then
      turnoff2 106,2,0
      event "i",106,0,999999
    elseif kmaprrate==1 then
      turnoff2 107,2,0
      event "i",107,0,999999
    elseif kmaprratedev==1 then
      turnoff2 108,2,0
      event "i",108,0,999999
    elseif kmapmix==1 then
      turnoff2 109,2,0
      event "i",109,0,999999
    elseif kmapport==1 then
      turnoff2 110,2,0
      event "i",110,0,999999
    elseif kmapsfspeed==1 then
      turnoff2 111,2,0
      event "i",111,0,999999
    endif
  endif
endif

if kmapliveampX==1 then
  turnoff2 102,2,0
elseif kmapDFactX==1 then
  turnoff2 103,2,0
elseif kmapFBX==1 then
  turnoff2 104,2,0
elseif kmapERampX==1 then
  turnoff2 105,2,0
elseif kmaprmaxX==1 then
  turnoff2 106,2,0
elseif kmaprrateX==1 then
  turnoff2 107,2,0
elseif kmaprratedevX==1 then
  turnoff2 108,2,0
elseif kmapmixX==1 then
  turnoff2 109,2,0
elseif kmapportX==1 then
  turnoff2 110,2,0
elseif kmapsfspeedX==1 then
  turnoff2 111,2,0
endif

endin

instr 102
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveamp"
endin

instr 103
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "DFact"
endin
instr 104
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "FB"
endin

instr 105
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1.5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ERamp"
endin

instr 106
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "rmax"
endin

instr 107
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.05,250 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "rrate"
endin

instr 108
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "rratedev"
endin

instr 109
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "mix"
endin

instr 110
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "port"
endin

instr 111
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.25,4 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "sfspeed"
endin

instr 120 ;MIDI mapping EQ
kmapboost chnget "mapboost"
kmapboostX chnget "mapboostX"
kmapf1 chnget "mapf1"
kmapf1X chnget "mapf1X"
kmapQ chnget "mapQ"
kmapQX chnget "mapQX"
kmapQ2 chnget "mapQ2"
kmapQ2X chnget "mapQ2X"
kmapdisp chnget "mapdisp"
kmapdispX chnget "mapdispX"

if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapboost==1 then
      turnoff2 121,2,0
      event "i",121,0,999999999
    elseif kmapf1==1 then
      turnoff2 122,2,0
      event "i",122,0,999999999
    elseif kmapQ==1 then
      turnoff2 123,2,0
      event "i",123,0,999999999
    elseif kmapQ2==1 then
      turnoff2 124,2,0
      event "i",124,0,999999999
    elseif kmapdisp==1 then
      turnoff2 125,2,0
      event "i",125,0,999999999
    endif
  endif
endif

if kmapboostX==1 then
  turnoff2 121,2,0
elseif kmapf1X==1 then
  turnoff2 122,2,0
elseif kmapQX==1 then
  turnoff2 123,2,0
elseif kmapQ2X==1 then
  turnoff2 124,2,0
elseif kmapdispX==1 then
  turnoff2 125,2,0
endif

endin

instr 121
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.5,1.5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "boost"
endin

instr 122
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,100,20000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "f1"
endin

instr 123
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.5,99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Q"
endin

instr 124
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.5,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Q2"
endin

instr 125
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "disp"
endin

instr   200 ;audio outputs
outo    (garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource),(garev5*gkFX)+(ga5mix*gksource),(garev6*gkFX)+(ga6mix*gksource),(garev7*gkFX)+(ga7mix*gksource),(garev8*gkFX)+(ga8mix*gksource) 
endin

instr 201   ;clear global audio
clear   ga1mix,ga2mix,ga3mix,ga4mix,ga5mix,ga6mix,ga7mix,ga8mix,garev1,garev2,garev3,garev4,garev5,garev6,garev7,garev8,gamic1,gamic2,gamic3,gamic4,gamic5,gamic6,gamic7,gamic8
endin

</CsInstruments>
<CsScore>

i1 0 999999
i5 0 999999
i10 0 999999
i100 0 999999
i101 0 999999
i120 0 999999
i200 0 999999
i201 0 999999

</CsScore>
</CsoundSynthesizer>